## Examples installation: examples.mak
# This file will install the examples component of the Hush package

# Main target
all : install

# Definition to hush the ..\general.mak warings
WIN32=1

# Global definitions
!include resource.mak       

# Requirements checking
!if !$d(EXAMPLES)
!message set EXAMPLES macro in $(INSTALLROOT)\resource.mak
!error EXAMPLES macro should have been defined
!endif

# Local definition
UNIXMAKEFILERENAME = unxrename.bat

.NOSILENT

# The real target: install 
install: $(MKDIR) $(UNIXMAKEFILERENAME)
    $(MKDIR) $(HUSH)\examples
    cls
    echo *** install examples ***
    echo *** install examples source files ***
    xcopy /s $(EXAMPLES) $(HUSH)\examples   > nul
    echo *** install examples makefiles ***
    xcopy /s makefiles $(HUSH)\examples > nul
    $(UNIXMAKEFILERENAME) $(HUSH)\examples\sim
    $(UNIXMAKEFILERENAME) $(HUSH)\examples\coffee
    $(UNIXMAKEFILERENAME) $(HUSH)\examples\widgets
    $(UNIXMAKEFILERENAME) $(HUSH)\examples\hush
    $(UNIXMAKEFILERENAME) $(HUSH)\examples\graphics
    $(UNIXMAKEFILERENAME) $(HUSH)\examples\drawtool
    $(UNIXMAKEFILERENAME) $(HUSH)\examples\adt
    $(UNIXMAKEFILERENAME) $(HUSH)\examples\contrib
    $(UNIXMAKEFILERENAME) $(HUSH)\examples\test
    $(UNIXMAKEFILERENAME) $(HUSH)\examples\vrml
    $(UNIXMAKEFILERENAME) $(HUSH)\examples\extensio
    copy makefile\resource.mak+&&|

TCLTK=$(TCLTK)
TOOLS=$(TOOLS)
HUSH=$(HUSH)
.SILENT

|+..\general.mak $(HUSH)\examples\resource.mak 
    echo *** install examples patches ***
    -xcopy /s patches $(HUSH)\examples  > nul
    del $(MKDIR)
    del $(UNIXMAKEFILERENAME)


# Do some cleaning
clean : delbatches

# The rename script:
# This script will rename all "makefile" files into "makefile.unx"
$(UNIXMAKEFILERENAME):
    copy &&|
@echo off
if not exist %1\makefile goto end
if exist %1\makefile.unx goto end
ren %1\makefile makefile.unx
:end
| $(UNIXMAKEFILERENAME) > nul
