## Hush examples make file

# If TARGETNAME is defined only that target will be build, otherwise all hush examples will be build
!ifndef TARGETNAME
all: all_hushs
!else
all: one_hush
!endif

# Target platform
WIN32=1

# Global definitions
!include ..\resource.mak

# Main target: build all examples
all_hushs :
    build dictiona
    build draw
    build events
    build explicit
    build generate
    build handler
    build implicit
    -build list
    build meta
    build session
    build string
    build tclstring
    build test
    build timer

# How to build just one example:
one_hush: $(CONFIG) $(TARGETNAME).exe 

# How to do cleanup
clean: $(RM)
    $(RM) *.exe
    $(RM) *.obj
    $(RM) *.cfg
    $(RM) *.out
    del $(RM)

cleanconfig: $(RM)
    $(RM) *.cfg

# Compiling and linking flags:
$(CONFIG):
    copy &&|
        -n$(OBJDIR) -I$(INCLUDES)
        -D$(DEFINES) $(CCFLAGS) 
| $(CONFIG) > nul

# If TARGETNAME has been defined, this will tell how to build the executable.

!ifdef TARGETNAME

$(TARGETNAME).exe: $(TARGETNAME).obj
    $(LINK) @&&|
$(LNFLAGS) $(TARGETNAME).obj 
$@
-x
$(LNLIBS)
|, &&|
EXETYPE WINDOWS
CODE PRELOAD MOVEABLE DISCARDABLE
DATA PRELOAD MOVEABLE MULTIPLE
|,  $(LIBDIR)\hush.res

!endif

#Implicit rules:
.c.obj:
    $(CC) { $< }
