#ifndef __sys_time_h
#define __sys_time_h

#include <dos.h>
#include <time.h>

// sys/time.h does not exist for dos, we make our own

struct timeval {
        long    tv_sec;         /* seconds */
        long    tv_usec;        /* and microseconds */
} ;

typedef struct timezone {
    long zone;
} ;

inline
void gettimeofday(struct timeval* tm,struct timezone* tz)
{
    struct time t;
    gettime(&t);
    tm->tv_sec = t.ti_hour;
    tm->tv_sec*=60;
    tm->tv_sec += t.ti_min;
    tm->tv_sec*=60;
    tm->tv_sec += t.ti_sec;
    tm->tv_usec = t.ti_hund+10;
    if (tz)
        tz->zone = _timezone;
}


#endif    // __sys_time_h
