all: lib

config:
test:

lib: list $(SHARE)

list: $(OBJECTS)
	echo "$(NAME) = $(OBJECTS)" > ../src/$(NAME).mk
	if [ $(NAME) != "src" ]; then cp $(OBJECTS) ../src; fi

shared: $(OBJECTS)
	rm -f $(LIB).so.* 
	$(LD) -o $(LIB).so.$(VERSION) $(OBJECTS) 

nonshared: $(OBJECTS)
	rm -f $(LIB).a
	ar cr $(LIB).a $(OBJECTS)
	$(RANLIB) $(LIB).a

install: lib 
	@echo -------- Installing $(LIB)  -- $(SHARE) -- in $(DEST)
	@if [ ! -d $(DEST)/lib ]; then mkdir $(DEST)/lib; fi
	@if [ $(SHARE) = "nonshared" ]; then \
		mv $(LIB).a $(DEST)/lib; \
		cd $(DEST)/lib; $(RANLIB) $(LIB).a; \
	else \
	mv $(LIB).so.$(VERSION) $(DEST)/lib; \
	set -x; cd $(DEST)/lib; \
	 rm -f $(LIB).so; ln -s $(LIB).so.$(VERSION) $(LIB).so; \
	fi;
	@echo ======== Installing $(LIB) completed == in $(DEST)

doc: index.html $(DOC)
	@echo -------- Documenting $(LIB)  -- in $(DEST)
	@if [ ! -d $(DEST)/doc ]; then mkdir $(DEST)/doc; fi
	@if [ ! -d $(DEST)/doc/api ]; then mkdir $(DEST)/doc/api; fi
	@if [ ! -d $(DEST)/doc/api ]; then mkdir $(DEST)/doc/api; fi
	@if [ ! -d $(DEST)/doc/api/dv/$(NAME) ]; \
	    then mkdir $(DEST)/doc/api/dv/$(NAME); fi
	cp index.html $(NAME).html
	cp *.html $(DEST)/doc/api/dv/$(NAME)
	@echo ======== Documenting $(LIB) completed == in $(DEST)

cleandoc:
	rm -f core *.html

test:
demo:

clean:
	rm -f core *.a *.o out *.out lib*.so.*  *.html
	rm -f -r Templates.DB
