#include <dv/tcl/callback.h>
#include <dv/tcl/event.h>
#include <dv/tcl/x.h>


//// event

tcl__event::tcl__event(class kit* _tk, int _argc, char* _argv[]) 
				    : event(this) {
	tk = _tk;
	__argc = _argc;
	__argv = _argv;
	}

tcl__event::~tcl__event() { }
int tcl__event::eventclass() const { return event::tcl; }
int tcl__event::argc() const { return __argc; }
char* tcl__event::arg(int i  ) const { return  argv()[i]; }
char** tcl__event::argv(int i ) const { return  __argv+i; } 
event* tcl__event::get() const { return (event*) new ::tcl_event(this); }

//// Callback structs

tcl_callback::tcl_callback() {
	tk = 0; proc = 0; data = 0;
	}
tcl_callback::tcl_callback(kit* _tk, void* _proc, void* _data ) {
	tk = _tk; proc = _proc; data = _data;
	}

//// Callback funs

void timer_callback( void* data ) {
	tcl_callback* x = (tcl_callback*) data;
	event* ev = new tcl__event(x->tk,0,0);
	handler* h = (handler*) x->data;
        if ( h->handler::mode() != handler::implicit)
	    h->handle_tcl_event( (tcl_event*) ev->get() );
	else    
	    h->dispatch(ev);
	delete ev;
	}


int handler_callback(void* data , kit* tk, int argc , char** argv) {
	 event* ev = new xevent(tk,argc,argv);
	 handler* h = (handler*) data;
	 if ( h->handler::mode() != handler::implicit)
	    h->handle_tcl_event( (tcl_event*) ev->get() );
	 else
	    h->dispatch(ev);
	 delete ev;
	 return 0;
}
