// file.c -- file event callbacks

#include <dv/tcl/file.h>
#include <dv/tcl/file_event.h>

//// event 

file__event::file__event(class kit* _tk,int _fd, int _mask,
			  int _argc, char* _argv[]) : event(this) {
	tk = _tk;
	__fd = _fd;
	__mask = _mask;
	__argc = _argc;
	__argv = _argv;
	}
file__event::~file__event() { }
int file__event::eventclass() const { return event::file; }
int file__event::argc() const { return __argc; }
char* file__event::arg(int i) const { return argv()[i]; }
char** file__event::argv(int i) const { return  __argv+i; } 
int file__event::fd() const { return __fd; }
int file__event::mask() const { return __mask; }
event* file__event::get() const { return (event*) new ::file_event(this); }


//// callback struct

file_callback::file_callback(handler* h_, int fd_): filehandler(h_), fd(fd_) {}


//// callback fun

int file_handler_callback(void* data , int mask) {
        file_callback *s = (file_callback*) data;
        const int count = 2; char* args[count+1];
        char mstr[20]; char fdstr[20];
        switch (mask) {
           case kit::readable:  sprintf(mstr, "%s", "readable"); break;
           case kit::writable:  sprintf(mstr, "%s", "writable"); break;
           case kit::exception: sprintf(mstr, "%s", "exception"); break;
           default: sprintf(mstr, "%s", "unknown-mask-error");
        }
        sprintf(fdstr, "%d", s->fd);
        args[0]=fdstr; args[1]=mstr; args[2]=NULL;

	event* ev = new file__event(thekit(),s->fd,mask,count,args);
	handler* h = s->filehandler;

        if ( h->handler::mode() != handler::implicit)
	    h->handle_file_event( (file_event*) ev->get() );
	else
	   (s->filehandler->dispatch(ev));
	delete ev;
	return 0;

        //return (s->filehandler->dispatch(thekit(), count, args));
}

