#include <hush/hush.h>
#include <dv/tcl/string.h>

#include <iostream.h>
#include <string.h>

extern "C" {
#include <tcl.h>
}

//iter<void>::iter( iter<void>* p_ ) { p = p_; }




class tclstringrep {
friend class tclstring;
private:
tclstringrep() {
	ds = &buffer;
	Tcl_DStringInit(ds);
	count = 1;
	}
~tclstringrep() {
	Tcl_DStringFree(ds);
	}
int count;
Tcl_DString* ds;
Tcl_DString buffer;
};

#define REP ((tclstringrep*)rep)


tclstring::tclstring() { init(); } 
tclstring::tclstring(const char* s) { init(); concat(s); }
tclstring::tclstring(const tclstring& a) { rep = a.rep; REP->count++; } 

tclstring::~tclstring() { if ( --REP->count <= 0 ) delete REP; }


tclstring& tclstring::operator=( char* s ) { 
	   if (--REP->count <= 0 ) delete REP;
	   init(); append(s);
	   return *this;
	   }

tclstring& tclstring::operator=( tclstring& a ) { 
	   ((tclstringrep*)a.rep)->count++;
	   if (--REP->count <= 0 ) delete REP;
	   rep = a.rep;
	   return *this;
	   }

tclstring& tclstring::start() {
	   Tcl_DStringStartSublist(REP->ds);
	   return *this;
	   }

tclstring& tclstring::end() {
	   Tcl_DStringEndSublist(REP->ds);
	   return *this;
	   }

tclstring& tclstring::trunc(int n) {
	   Tcl_DStringTrunc(REP->ds,n);
	   return* this;
	   }

tclstring& tclstring::concat(const char* s) {
           Tcl_DStringAppend(REP->ds,(char*)s,strlen(s));
	   return *this;
	   }

tclstring& tclstring::concat( const tclstring& a ) {
	   Tcl_DStringAppend(REP->ds, a.value(), strlen(a.value()));
	   return *this;
	   }

tclstring& tclstring::append( const char* s ) {
           Tcl_DStringAppendElement(REP->ds, tclstring(s));
	   return *this;
	   }

tclstring& tclstring::append( const tclstring& a ) {
	   Tcl_DStringAppendElement(REP->ds, a.value());
	   return *this;
	   }

int tclstring::length() const { return Tcl_DStringLength(REP->ds) + 1; } 

char* tclstring::value() const { return Tcl_DStringValue(REP->ds); }

int tclstring::match(const char* s) const {
	return Tcl_StringMatch(value(),(char*)s);
	}
	
int tclstring::regmatch(const char* s) const {
	return Tcl_RegExpMatch((Tcl_Interp*)tk->interp(),value(),(char*)s);
	}

char* tclstring::tilde() const {
	Tcl_DString x; char* p;
	return p = Tcl_TildeSubst((Tcl_Interp*)tk->interp(), value(), &x );
	}




void tclstring::init() { rep = (tclstringrep*) new tclstringrep(); 
			 tk = thekit(); }



char* tclstring::lindex(int n) const {
	char* p;
	char* buf = new char[ length() + 20 ];
	sprintf(buf,"lindex \"%s\" %d",value(),n);
	p = tk->evaluate( buf );
	delete buf;
	return p;
	}

char* tclstring::lindex(char* options) const {
	char* p; int n;
	char* buf = new char[ length() + 20 ];
	if (!strcmp(options,"first")) n = 0;
	else if (!strcmp(options,"last")) n = llength();
	else sscanf(options,"%d",&n);
	sprintf(buf,"lindex \"%s\" %d",value(),n);
	p = tk->evaluate( buf );
	delete buf;
	return p;
	}

int tclstring::llength() const {
	char buf[BUFSIZ];
	sprintf(buf,"llength \"%s\"",value());
	int n = 0; sscanf(tk->evaluate( buf ),"%d",&n);
	return n;
	}
