#include <hush/hush.h>
#include <widgets/canvas.h>
#include <hush/kit.h>
#include <hush/action.h>

#include <dv/tk/citem.h>

#include <iostream.h>

c_item::c_item() : item() {
	n = 0; c = 0; tk = thekit(); 
	}

c_item::c_item(int i, class canvas* x) : item() {
	n = i; c = x; tk = thekit();
	}

// sneaky:
c_item::c_item(int i, const char* x) : item() {
	n = i; c = new class canvas(x,0);
	tk = thekit();
	}

// c_item::c_item(c_item& id) { n = id.n; c = id.c; tk = thekit(); }

c_item::~c_item() {
	if (tk->tracelevel() > 4)
		cerr << "c_item::~c_item " << this << endl;
	}

int c_item::no() const { return n; }
char* c_item::id() const { return ""; }



void c_item::move(int x, int y) { c->move(n,x,y); }
void c_item::del() { c->del(n); }
void c_item::tag(const char* s) { c->tag(n,s); }
char* c_item::tags() const { return c->tags(n); }
void c_item::configure(const char* s) { c->itemconfigure(n,s); }


c_item::bind(const char* s, const char* cmd, const char* args ) {
	action* ac = tk->action(cmd);
	return direct(s,ac,args);
	}

c_item::bind(const char *s, class handler* h, const char* args) {
	action* ac = tk->action(h);
	return direct(s,ac,args);
	}

c_item::bind(const char *s, void* f, void* cl, const char* args) {
	action* ac = tk->action(f,cl);
	return direct(s,ac,args);
	}

c_item::bind(const char *s, action* ac, const char* args) {
        return direct(s,ac,args);
	}

/// For GNU's sake ...


c_item::bind(class handler* h, const char* args  ) {
	action* ac = tk->action(h);
	install(ac,args);
	return 0;
	}

c_item::bind(void* proc, void* data , const char* args ) {
	action* ac = tk->action(proc,data);
	install(ac, args);
	return 0;
	}

c_item::bind( action* ac, const char* args  ) {
	install(ac, args);
	return 0;
	}

#ifndef NOHANDLER
void c_item::handler( action* ac, const char* args  ) {
	install(ac, args);
	}

void c_item::handler(const char* cmd, const char* args ) {
	action* ac = tk->action(cmd);
	install(ac,args);
	}

void c_item::handler(void* proc, void* data , const char* args ) {
	action* ac = tk->action(proc,data);
	install(ac, args);
	}

void c_item::handler(class handler* h, const char* args  ) {
	action* ac = tk->action(h);
	install(ac,args);
	}
#endif


void c_item::install(action* ac, const char* args ) {
	bind("<Any-ButtonPress>",ac, args);
	bind("<Any-ButtonRelease>",ac, args);
	bind("<Any-Motion>",ac, args );
	bind("<Enter>",ac, args );
	bind("<Leave>",ac, args );
	}

c_item::direct(const char*s, action* ac, const char* args) {
	return c->itembind(n,s,ac,args);
	}
