#include <widgets/barchart.h>

char* barchart::type() const { return "barchart"; }

barchart::barchart(const char* p, const char* options) : widget(p) {
	if(options) init(options);
	}

barchart::barchart(const widget* w, const char* p, const char* options) : widget(w,p) {
	if(options) init(options);
	}

void barchart::install(action* ac, const char* args) { 
	bind("<Any-ButtonPress>",ac, args);
	bind("<Any-ButtonRelease>",ac, args);
	bind("<Any-Motion>",ac, args);
	}

void barchart::insert(const char* s, float y, const char* options) {
	sprintf(buf,"%s insert %s -y %f  %s",path(),s,y,options);
	tk->eval( buf );
	}

void barchart::barconfigure(const char* s, const char* options) {
	sprintf(buf,"%s barconfigure %s %s",path(),s,options);
	tk->eval( buf );
	}

char* barchart::bar(int x, int y) {
	sprintf(buf,"whichbar %s %d %d",path(),x,y);
	return tk->evaluate(buf);
	}

float barchart::y(int ex, int ey) {
	sprintf(buf,"lindex [%s locate %d %d] 1",path(),ex,ey);
	float f = 0; sscanf(tk->evaluate(buf),"%f",&f);
	return f;
	};

void barchart::ydata(const char* bar, float f) {
	sprintf(buf,"%s barconfigure %s -ydata %f",path(),bar,f);
	tk->eval( buf );
	}
