#include <widgets/bargraph.h>

char* bargraph::type() const { return "bargraph"; }

bargraph::bargraph(const char* p, const char * options) : widget(p) {
	if(options) init(options);
	}

bargraph::bargraph(const widget* w, const char* p, const char * options) : widget(w,p) {
	if(options) init(options);
	}

void bargraph::text(const char* s) {
	sprintf(buf,"%s configure -label {%s}", path(), s);
	tk->eval( buf );
	}

void bargraph::from(int n) {
	sprintf(buf,"%s configure -min %d", path(), n);
	tk->eval( buf );
	}

void bargraph::to(int n) {
	sprintf(buf,"%s configure -max %d", path(), n);
	tk->eval( buf );
	}

int bargraph::get() const {
	sprintf(buf,"%s get",path());
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return n;
	}

void bargraph::set(int v) {
	sprintf(buf,"%s set %d",path(),v);
	tk->eval( buf );
	}

void bargraph::interval(int n) {
	sprintf(buf,"%s configure -interval %d",path(),n);
	tk->eval( buf );
	}

void bargraph::start() {
	sprintf(buf,"%s start", path());
	tk->eval( buf );
	}

void bargraph::stop() {
	sprintf(buf,"%s stop", path());
	tk->eval( buf );
	}

void bargraph::install(action* ac, const char* args) {
	sprintf(buf,"%s configure -command {%s %s}",path(),ac->name(),args);
	tk->eval( buf );
	}
