#include <widgets/filechooser.h>
#include <hush/event.h>
#include <hush/action.h>

#include <iostream.h>
#include <string.h>

class kit;

char* filechooser::type() const { return "filechooser"; }

filechooser::filechooser() : widget(".exemplar_filechooser") {}

filechooser::filechooser(const char* p, const char * options ) : widget(p) { if(options) initfc(20,12,options); }
filechooser::filechooser(const widget* w, const char* p, const char * options ) : widget(w,p) { if(options) initfc(20,12,options); }



char* filechooser::get() {
	sprintf(buf,"%s.f.e get",path());
	return tk->evaluate( buf );
	}

void filechooser::cancel(const char* s) {
	sprintf(buf,"%s.f.c configure -command {%s}",path(),s);
	tk->eval( buf );
	}


void filechooser::install(action* ac, const char* args) {
	sprintf(buf,"%s.f.b configure -command {%s [%s.f.e get] %s}",path(),ac->name(),path(),args);
	tk->eval( buf );
	}

void filechooser::initfc(int w , int h, const char* options ) {
	sprintf(buf,"filechooser::mk %s %d %d %s",path(),w,h,options);
	tk->eval( buf );
	sprintf(buf,"bind %s.l.list <Double-Button-1> {foreach i [selection get] {filechoo::browse %s \".\" $i}}",path(),path());
	tk->eval( buf );
	}



int filechooser::operator()() {
	f = this;
	int argc = _event->argc(); char** argv = _event->argv();
	if ( !strcmp("filechooser",*argv) ) return fcreate(tk, --argc, ++argv);
	argv++; 
	while ( argc-- > 1 ) {
	if ( !strcmp("configure",*argv) ) return options(tk, argc,++argv);
	if ( !strcmp("get",*argv) ) { if(f) f->get(); return 0; }
	else cout << " no such option " << endl;
	argv++;
	}
	return 0;
}

int filechooser::fcreate(kit* _tk , int argc, char** argv) { 
	f = new filechooser(*argv);
	_tk->action(*argv,f);
	_tk->result(*argv);
	return options(_tk,--argc,++argv);
	}

int filechooser::options(kit* tk, int argc, char** argv ) {
	while ( argc > 1 ) {
	if ( !strcmp("-command",*argv) ) {
		sprintf(buf,"%s.f.b configure -command {%s}",f->path(),*++argv);
		tk->eval( buf );
		}
	else cout << " no such option " << endl;
	argv++; argc--;
	}
	tk->result(f->path());
	return 0;
}
