#include <hush/hush.h>
#include <widgets/glwin.h>
#include <widgets/frame.h>
#include <string.h>


char* glwin::type() const { return "glwin"; }

glwin::glwin() : widget() { }

glwin::glwin(const char* p, const char* options) : widget(p) {
	if (options) init(options);
	}

glwin::glwin(const widget* w, const char* p, const char* options) : widget(w,p) { 
	if (options) init(options);
	}

void glwin::geometry(int x, int y) {
	sprintf(buf,"%s configure -width %d -height %d",thepath(),x,y);
	tk->eval( buf );
	}

void glwin::configure(const char* s) { 
	sprintf(buf,"%s configure %s",thepath(),s);
	tk->eval( buf );
	}

void glwin::link() { 
	sprintf(buf,"%s link",thepath());
	tk->eval( buf );
	}

void glwin::init(const char* options) {

widget* top = new frame( path() );
widget* glx = new widget(top,"glx");

sprintf(buf,"glxwin %s %s", glx->path(), options);
tk->eval( buf );

glx->pack(); // don t forget to pack

redirect( glx ); // not superfluous !

alias( this );
}


int glwin::operator()(){ /// (II)
	int argc = _event->argc(); char** argv = _event->argv();
        if (!strcmp("self",argv[1]) ) tk->result(self()->path());
        else if ( !strcmp( "glwin" ,*argv) )
					  create(--argc,++argv); 
        else self()->eval( flatten(--argc,++argv) );
        return 0;
	}

void glwin::create(int argc, char* argv[]) { /// (III)
        char* name = *argv;
        new glwin(name, flatten(--argc,++argv));
        }

void glwin::install(action* ac, const char* args) {
        self()->bind("<Any-ButtonPress>",ac, args);
        self()->bind("<Any-ButtonRelease>",ac, args);
        self()->bind("<Any-Motion>",ac, args );
        self()->bind("<Enter>",ac, args );
        self()->bind("<Leave>",ac, args );
        }

