#include <widgets/xygraph.h>

char* xygraph::type() const { return "xygraph"; }
//char* type() { return "blt_graph"; }

xygraph::xygraph(const char* p, const char* options) : widget(p) {
	if (options) init(options);
	}

xygraph::xygraph(const widget* w, const char* p, const char* options ) : widget(w,p) {
	if (options) init(options); 
	}


void xygraph::geometry(int x, int y) {
	sprintf(buf,"%s configure -geometry %dx%d ",path(),x,y);
	tk->eval( buf );
	}

void xygraph::xycreate(const char* s, const char* options) {
	obsolete("use xygraph::insert");
	sprintf(buf,"%s insert %s %s",path(),s,options);
	tk->eval( buf );
	}

void xygraph::del(const char* s) {
	sprintf(buf,"%s delete %s",path(),s);
	tk->eval( buf );
	}

void xygraph::domain(float b, float e) {
	sprintf(buf,"%s configure -xminimum %f -xmaximum %f",path(),b,e);
	tk->eval( buf );
	}

void xygraph::range(float b, float e) {
	sprintf(buf,"%s configure -yminimum %f -ymaximum %f",path(),b,e);
	tk->eval( buf );
	}


void xygraph::insert(const char* s, const char* options) {
	sprintf(buf,"%s insert %s %s",path(),s,options);
	tk->eval( buf );
	}

void xygraph::add(const char* s, const char* x, const char* y, const char* options) {
	sprintf(xbuf,"%s insert %s -xdata {%s} -ydata {%s} %s",path(),s,x,y,options);
	tk->eval( xbuf );
	}

void xygraph::add(const char* s, float x, float y, const char* options) {
	sprintf(buf,"%s lineconfigure %s { %f %f } %s",path(),s,x,y,options);
	tk->eval( buf );
	}

/*
char* bar(int x, int y) {
	sprintf(buf,"whichbar %s %d %d",path(),x,y);
	return tk->evaluate(buf);
	}
*/

float xygraph::y(int ex, int ey) {
	sprintf(buf,"lindex [%s locate %d %d] 1",path(),ex,ey);
	float f = 0; sscanf(tk->evaluate(buf),"%f",&f);
	return f;
	};

void xygraph::lineconfigure(const char* line, const char* options) {
	sprintf(buf,"%s lineconfigure %s %s",path(),line,options);
	tk->eval( buf );
	}


/*
void init(const char* options) {
	sprintf(buf,"%s %s %s","blt_graph",path(),options);
	tk->eval( buf );
	}
*/


void xygraph::install(action* ac, const char* args) { 
	bind("<Any-ButtonPress>",ac, args);
	bind("<Any-ButtonRelease>",ac, args);
	bind("<Any-Motion>",ac, args);
	}
