all: $(OUT) 

config: touch resource.mk
touch:; touch resource.in

test:; make -f mkfile test 

demo:; make -f mkfile demo 

install: 
	if [ ! -d $(HUSH)/examples ]; then mkdir $(HUSH)/examples; fi
	if [ ! -d $(HUSH)/examples/$(NAME) ]; \
				 then mkdir $(HUSH)/examples/$(NAME); fi
	cp -r $(FILES) $(SUBDIRS) $(HUSH)/examples/$(NAME)
	cp mkfile $(HUSH)/examples/$(NAME)/Makefile

doc: $(DOC)
	@echo -------- Documenting $(NAME)  -- in $(HUSH)
	@if [ ! -d $(HUSH)/doc ]; then mkdir $(HUSH)/doc; fi
	@if [ ! -d $(HUSH)/doc/examples ]; then mkdir $(HUSH)/doc/examples; fi
	@if [ ! -d $(HUSH)/doc/examples/$(NAME) ]; \
	    then mkdir $(HUSH)/doc/examples/$(NAME); fi
	@cp index.html $(NAME).html
	@cp *.html $(HUSH)/doc/examples/$(NAME);
	@echo ======== Installing $(NAME) completed == in $(HUSH)

cleandoc:
	rm -f *.html

clean:
	rm -f core *.a *.o out *.out lib*.so.*  *.html
	rm -f -r Templates.DB
