#include "hush.h" /// [1]
#include <hush/assert.h>
#include <extern/safe.h>

class application : public session {  /// [3]
public:
application( int argc, char* argv[] ) : session(argc,argv,0) {}

int main() {
    init_safe( tk );
    tk->trace();
    int i = 1; int j = 2;
    kit* tki = tk->slave();
    cerr << tk->result() << endl;
    require( tki );
    int istat = tki->eval("open /tmp/temp w"); 
    if (istat) cerr << ": " << tki->result() << ":: " << istat << endl;
    kit* tkj = tk->slave("-safe");    /// SAFE
    cerr << tk->result() << endl;
    require( tkj );
    int jstat = tkj->eval("open /tmp/temp w"); 
    if (jstat) cerr << j << ": " << tkj->result() << ":: " << jstat << endl;
    cerr << i << " :";
    if ( tki->safe() ) cerr << " safe" << endl;
	else cerr << " unsafe (as expected)" << endl;
    cerr << j << " :";
    if ( tkj->safe() ) cerr <<  " safe (as expected)" << endl;
	else cerr << " unsafe" << endl;

    istat = tki->eval("source safe.tcl");
    if (istat) cerr << i << ": " << tki->result() << endl;
    istat = tki->eval("try temp0");
    if (istat) cerr << i << ": " << tkj->result() << endl;
    jstat = tkj->eval("source safe.tcl");
    if (jstat) cerr << j << ": " << tkj->result() << endl;
    jstat = tkj->eval("try temp1");
    if (jstat) cerr << j << ": " << tkj->result() << endl;
    int stat = tk->eval("try temp1");
    if (stat) cerr << " as expected (top) :: " << tk->result() << endl;
    tki->eval("puts {end of 1}");
    tkj->eval("puts {end of 2}");
    return OK;
    }

};

int main (int  argc, char* argv[]) { /// [4]
    session* s = new application(argc,argv);
    return s->run();
}
