#include <hush/hush.h>
#include <hush/dictionary.h>

#include <iostream.h>
#include <string.h>

extern "C" {
#include <tcl.h>
}

//iter<void>::iter( iter<void>* p_ ) { p = p_; }


static void* dummy;
static iter<void> dummy_iter(0);
static dictionaryentry<void> dummy_entry(dummy);
static dictionary<handler> handler_dummy;
static dictionary<widget> widget_dummy;
static dictionary<action> action_dummy;

void* iter_dummy_function() {
iter<void> unlikely_dummy_iter(&dummy_iter);
return unlikely_dummy_iter();
}


void set_dictionaryentry(void* p, void* v) {
   Tcl_SetHashValue( (Tcl_HashEntry*) p, (ClientData) v);
   }

void* get_dictionaryentry(void* p) {
   //cerr << "calling Get" << endl;
   return Tcl_GetHashValue( (Tcl_HashEntry*) p);
   }


rawdictionary::rawdictionary() {
	tbl = new Tcl_HashTable;
	Tcl_InitHashTable((Tcl_HashTable*)tbl,TCL_STRING_KEYS);
	}

rawdictionary::~rawdictionary() {
	Tcl_DeleteHashTable((Tcl_HashTable*)tbl);
	}


void rawdictionary::entry(char* k, void* v) {
	int n;
	Tcl_HashEntry* p;
	do {
		p = Tcl_CreateHashEntry((Tcl_HashTable*)tbl,k, &n);
	} while( !n );
	Tcl_SetHashValue(p, (ClientData) v);
	}

void* rawdictionary::find(char* k) {
	Tcl_HashEntry* p;
	p = Tcl_FindHashEntry((Tcl_HashTable*)tbl,k);
	if (!p)  cerr << "error finding " << k << endl;
	return  Tcl_GetHashValue(p);
	}

void* rawdictionary::del(char* k) {
	Tcl_HashEntry* p;
	p = Tcl_FindHashEntry((Tcl_HashTable*)tbl,k);
	if (!p)  cerr << "error finding " << k << endl;
	void* v =  Tcl_GetHashValue(p);
	Tcl_DeleteHashEntry( p );
	return v;
	}

char* rawdictionary::stats() {
	return Tcl_HashStats( (Tcl_HashTable*)tbl );
	}
	
void* rawdictionary::operator()(char* k) { return find(k); }

dictionaryentry<void>*
rawdictionary::operator[](char* k) {  /// trick to allow assignment
	int n = -1;
	Tcl_HashEntry* p;
	do {
		p = Tcl_CreateHashEntry((Tcl_HashTable*)tbl,k, &n);
	} while( n < 0 );
	return  new dictionaryentry<void>( p );
	}
	


class rawdictionaryiter : public iter<void> {
public:
rawdictionaryiter(Tcl_HashTable* tbl_) : iter<void>(this) {
	tbl = tbl_; sp = &s;
	p = Tcl_FirstHashEntry(tbl,sp);
	//if (p) cout << "oke"; else cout << "wrong"; cout << endl;
	}

void dummy(void*) { }

void* operator()() {
	//if (p) cout << "oke"; else cout << "wrong"; cout << endl;
	void* v = p ? (void*) Tcl_GetHashValue(p) : 0;
	p = Tcl_NextHashEntry(sp);
	return v;
	}
	
private:
Tcl_HashSearch* sp;
Tcl_HashTable* tbl;
Tcl_HashSearch s;
Tcl_HashEntry* p;
};


iter<void>* rawdictionary::search() {
	return  new rawdictionaryiter((Tcl_HashTable*)tbl); 
	}



