#include <hush/event.h>

#include <hush/config.h>

#include <hush/assert.h>

#include <dv/tcl/callback.h>
#include <dv/tcl/event.h>




#include <hush/system.h>

#include <iostream.h>
#include <string.h>


system_event::system_event(const event* e) : _ev((event*)e) { }
system_event::~system_event() { }
int system_event::eventclass() const { return event::user; }
char* system_event::info() const { return "system_event"; }
int system_event::check() const { 
	int b =  (_ev->eventclass() == eventclass());
	if (!b) error( info() );
	return b;
	};

void system_event::error(const char*s) const {
	cerr << "ERROR: " << s << "(" << eventclass() <<
	  ")" << endl;
	  }


//// Mod events

#include <dv/mod.h>


modevent::modevent(const char* s) : event(this), _name((char*)s) {}

modevent::modevent(event* e) : event(e), _name(0) { }

char* modevent::name() const { return _name?_name:"anevent"; }


//// The event class


//// Existence?:

int event::exists() const { return _body && ( _body != this ); }

//// Constructors:

//char* info() const { return exists()?_body->info():"event"; }
//kit* thekit() const { return exists()?_body->thekit():thekit(); }

event::event(class kit* _tk, int _argc, char** _argv) : _del(1)  {
	_body = new tcl__event(_tk, _argc, _argv);
	}

event* event::get() const { 
	return exists()?_body->get():0;
	}

int event::argc() const {
	return exists()?_body->argc():0;
	}

int event::fd() const {
	return exists()?_body->fd():-1;
	}

int event::mask() const {
	return exists()?_body->mask():0;
	}

char** event::argv(int i ) const {
	return exists()?_body->argv(i):0;
	}

char* event::arg( int i ) const {
	return exists()?_body->arg(i):0;
	}

event::event(const char* s) : _del(1) { _body = new modevent(s); }

event::event(int qp,int sp,int k) : _del(1) {  /// for sim
	_body = a_simulation_event(qp,sp,k);
	}

event::event(const event& e) {
	_body = e._body;
	_del = e._del;
	}

event::event(event* e) : _body(e)   {
	_del = 0;
}


event::~event() {
	//if (ev && _del) delete ev; ev = 0;
	}

int event::eventclass() const { return 0; } /// TODO?

//// dispatching


int event::operator()() {
	//cerr << "event operator" << endl;
	return handler::operator()();
	}

//// general

int event::type() const { return exists()?_body->type():0; } /*press*/
char* event::name() const { return exists()?_body->name():"anonymous"; }
void event::trace() const { if (exists()) _body->trace(); }

int event::no() const { return exists()?_body->no():0; }
char* event::id() const { return exists()?_body->id():"anonymous"; }

//// x-event

int event::x() const { return exists()?_body->x():0; }
int event::y() const { return exists()?_body->y():0; } 
int event::x_root() const { return exists()?_body->x_root():0; }
int event::y_root() const { return exists()?_body->y_root():0; } 
int event::button(int i) const { return exists()?_body->button(i):0; }
int event::buttonup(int i) const { return exists()?_body->buttonup(i):0; }
int event::keycode() const { return exists()?_body->keycode():0; }
int event::buttonevent(int i) const { return exists()?_body->buttonevent(i):0; }
int event::keyevent() const { return exists()?_body->keyevent():0; }
int event::motion() const { return exists()?_body->motion():0; }
void event::motion( event& ) { }
void* event::rawevent() { return exists()?_body->rawevent():0; }

//// sim-event

int event::report(histogram* hi,double interv) { 
	return exists()?_body->report(hi,interv):0;
	} 
void  event::stamp() { if (exists()) _body->stamp(); }

double  event::timespent() { return exists()?_body->timespent():0; }

char*  event::reporttitle() { return exists()?_body->reporttitle():0; }
double  event::time() const { return exists()?_body->time():0; }
void  event::time(double t) { if (exists()) _body->time(t); }
int  event::schedulingpriority() { return exists()?_body->schedulingpriority():0; }
void  event::schedulingpriority(int p) { if (exists()) _body->schedulingpriority(p); }
int  event::queuingpriority() { return exists()?_body->queuingpriority():0; }
void  event::queuingpriority(int p) { if (exists()) _body->queuingpriority(p); }
double  event::interval() { return exists()?_body->interval():0; }
void  event::interval(double i) { if (exists()) _body->interval(i); }
int  event::state() { return exists()?_body->state():0; }
void  event::state(int s) { if (exists()) _body->state(s); }
int  event::killflag() { return exists()?_body->killflag():0; }
event*  event::leftpointer() { return exists()?_body->leftpointer():0; }
void  event::leftpointer(event* l) { if (exists()) _body->leftpointer(l); } 
event*  event::middlepointer() { return exists()?_body->middlepointer():0; }
void  event::middlepointer(event* l) { if (exists()) _body->middlepointer(l); }
event*  event::rightpointer() { return exists()?_body->rightpointer():0; }
void  event::rightpointer(event* l) { if (exists()) _body->rightpointer(l); }
event*  event::parentpointer() { return exists()?_body->parentpointer():0; }
void  event::parentpointer(event* l) { if (exists()) _body->parentpointer(l); }
double  event::waitingreporttime() { return exists()?_body->waitingreporttime():0; }
void  event::waitingreporttime(double w) { if (exists()) _body->waitingreporttime(w); }
double  event::eventreporttime() { return exists()?_body->eventreporttime():0; }
int  event::active() { return exists()?_body->active():0; }
int  event::pending() { return exists()?_body->pending():0; }
int  event::conditional() { return exists()?_body->conditional():0; }
int  event::closed() { return exists()?_body->closed():0; }
int  event::passive() { return exists()?_body->passive():0; }
int  event::queued() { return exists()?_body->queued():0; }
