#include <hush/item.h>


item::item() : it(0), _del(0) { }
item::item(const char*) : it(0), _del(0) { }
item::item(item* x) : it(x), _del(1) { }

item::item(item& x) { 
	it = x.it;
	x._del = 0;
	_del = 1;
	}

item& item::operator=(item& x) {
	//if (it) delete it;
	it = x.it;
	x._del = 0;
	_del = 0;
	return *this;
	}

item::~item() {
	if (it && _del) {
		delete it;
		}
	}

int item::no() const { return it?it->no():0; }

char* item::id() const { return it?it->id():0; }

item::operator int() const { return it?it->no():0; }
//item::operator char*() const { return it?it->id():0; }

item* item::operator ->() { return it?it:this; }

void item::tag(const char* s) { if (it) it->tag(s); }
char* item::tags() const { return it?it->tags():0; }

void item::configure(const char* s) { if (it) it->configure(s); }

void item::move(int x, int y) {
	if (it) it->move(x,y);
	}

void item::del() { if (it) it->del(); }

/// bonding

int item::bind(const char *s, const char* cmd, const char* args) {
	return it?it->bind(s,cmd,args):0;
	}

int item::bind(const char *s, class handler* h, const char* args) {
	item* x = it;
	return x?x->bind(s,h,args):0;
	}


int item::bind(const char *s, void* f, void* c, const char* args) {
	return it?it->bind(s,f,c,args):0;
	}

int item::bind(const char *s, action* a, const char* args ) {
	return it?it->bind(s,a,args):0;
	}

/// For Gnu

/*
int item::bind(const char* cmd, const char* args) {
	return it?it->bind(cmd,args):0;
	}
*/

int item::bind(class handler* h, const char* args ) {
	return it?it->bind(h,args):0;
	}

int item::bind(void* f, void* c, const char* args) {
	return it?it->bind(f,c,args):0;
	}

int item::bind(action* ac, const char* args ) {
	return it?it->bind(ac,args):0;
	}

int item::direct(const char*s, action* ac, const char* args) {
	return it?it->direct(s,ac,args):0;
	}

#ifndef NOHANDLER
void item::handler( action* ac, const char* args) {
	if (it) it->handler(ac,args);
	}

void item::handler(const char* cmd, const char* args) {
	if (it) it->handler(cmd,args);
	}

void item::handler(void* proc, void* data, const char* args) {
	if (it) it->handler(proc,data,args);
	}


void item::handler(class handler* h, const char* args ) {
	if (it) it->handler(h,args);
	}

#endif

class widget* item::widget() {
	return it?it->widget():0;
	}


void item::install(action* ac, const char* args) {
	if (it) it->install(ac,args);
	}
