//// The hush kit -- kit.c
// See kit(4), issues(4), <hush/kit.h>.

#include <hush/kit.h>

#include <hush/event.h>
#include <hush/action.h>

#include <hush/config.h>

#include <iostream.h>

static event nullev;

kit::kit(kit*) : tk(0) { }
kit::kit(const char* x) { tk = a_new_kit(x); }

kit::~kit() { /* if (tk) delete tk; */ }

int kit::eval(const char* cmd) { 
	int result = tk?tk->eval(cmd):0;
	return result;
	}

char* kit::evaluate(const char* cmd) {
	if (tk) {
		tk->eval(cmd);
		return result();
		}
	return 0;
	}

char* kit::result() const { return tk?tk->result():0; }
void kit::result(const char* s) { if (tk) tk->result(s); }

int kit::source(const char* f) { return tk?tk->source(f):0; }

int kit::error() { return tk?tk->error():0; }
void kit::error(const char* msg) { if (tk) tk->error(msg); }

void kit::after(int n, const char* cmd) { if (tk) tk->after(n,cmd); }
void kit::after(int n, void* f, void* c) { if (tk) tk->after(n,f,c); }
void kit::after(int n, handler* h) { if (tk) tk->after(n,h); }

char* kit::send(const char* it, const char* cmd) { 
	return tk?tk->send(it,cmd):0;
	}

char* kit::selection(const char* options) const {
	return tk?tk->selection(options):0;
	}

void kit::update(const char* options) { if (tk) tk->update(options); }


int kit::safe() const {
	return tk?tk->safe():0;
	}

kit* kit::slave( char* options ) {
	return tk?tk->slave(options):0;
	}


void kit::bind(const char* name, handler* h) {
	::action* e = action(name,h);
	delete e;
	}

void kit::bind(const char* name, void* c, void* data) {
	::action* e = action(name,c,data);
	delete e;
	}

void kit::bind(int fd, handler* h, int mask) {
	::action* e = action(fd,h,mask);
	delete e;
	}
 
void kit::unbind(int fd) {
	if (tk) tk->unbind(fd);
	}

void kit::unbind(char* name, char* newname) {
	if (tk) tk->unbind(name,newname);
	}


class action* kit::action(const char* name) {
	return tk?tk->action(name):0;
	}

class action* kit::action(const char* name, handler* h) {
	return tk?tk->action(name,h):0;
	}

class  action* kit::action(const char* name, void* proc, void* data) {
	return tk?tk->action(name,proc,data):0;
	}

class action* kit::action(handler* h) {
	return tk?tk->action(h):0;
	}

class  action* kit::action(void* proc, void* data) {
	return tk?tk->action(proc,data):0;
	}

class  action* kit::action(int fd, handler* h, int mask) { // jrvosse
	return tk?tk->action(fd,h, mask):0;
	}


void kit::command(int fd, void* proc, void* data, int mask) {
	if (tk) tk->command(fd,proc,data,mask);
	}

void kit::command(const char* name, void* proc, void* data) {
	if (tk) tk->command(name,proc,data);
	}


void kit::quit() { if (tk) tk->quit(); }

void kit::trace(int i) { if (tk) tk->trace(i); }
void kit::notrace() { if (tk) tk->notrace(); }
int kit::tracelevel() const { return tk?tk->tracelevel():0; }

widget* kit::root() const { return tk?tk->root():0;}

widget* kit::pack(widget* w, const char* options) {
	return tk?tk->pack(w,options):0; 
	}

widget* kit::pack(const char* w, const char* options) {
	if ( tracelevel() > 5 )
		cerr << "kit::pack (char*)" << endl; 
	return tk?tk->pack(w,options):0;
	}

int kit::callback(void* c,void* k, int argC, char* argV[]) {
	return tk?tk->callback(c,k,argC,argV):0;
	}

int kit::mode() const { return tk?tk->mode(0):0; } // XX repair!!
int kit::mode(int i) { return tk?tk->mode(i):0; }
int kit::mode(const char* i) { return tk?tk->mode(i):0; }
	
void* kit::interp() const { return tk?tk->interp():0; }
void* kit::tkwin() const { return tk?tk->tkwin():0; }

void kit::put(event* p,int fl) { if (tk) tk->put(p,fl); }

event* kit::get() const { 
	if ( tracelevel() > 5 )
	        cerr << "kit is asked for an event" << endl;
	return tk?tk->get():0; //new class event("dummy");
	}

//// Experimental -- role switching


kit* kit::become(char* s, kit* k) {
	cerr << "NYET : kit::become" << endl;
	return tk;
	}

void restore(kit* k) {
	cerr << "NYET : kit::restore" << endl;
	}
