#include <hush/list.h>


dvlist_cell::dvlist_cell(void* hd, dvlist_cell* tl) : el(hd), next(tl) {
       _igarb = 0; _lgarb = 0; _cnt = 0; _level = 0;
       }

void dvlist_cell::_register(dvlist_cell* p) {
	p->_level++;
	if (!_lgarb) _lgarb = new dvlist_cell;
	_lgarb->insert(p);
	}

void dvlist_cell::_register(iter<void>* p) {
	if (!_igarb) _igarb = new dvlist_cell;
	_igarb->insert(p);
	}

dvlist_cell::~dvlist_cell() {
 if (_cnt == 0 ) {
	while (_lgarb) {
		dvlist_cell* p = (dvlist_cell*) _lgarb->el;
		if (p) {
			delete p;
			}
		_lgarb = _lgarb->next;
		}
	while (_igarb) {
		iter<void>* p = (iter<void>*) _igarb->el;
		if (p) {
			delete p;
			}
		_igarb = _igarb->next;
		}
	if ( !_level && next) delete next;
 } else _cnt--;
} 

int dvlist_cell::empty() const { return el?0:1; }
int dvlist_cell::length() const { 
	    return el?(1 + next?next->length():0):1;
	    }


int dvlist_cell::contains(void* e) const {
if (e == el) return 1;
else if (!next) return 0;
else return next->contains(e);
}

int dvlist_cell::count(void* e) const {
iter<void> it = *this->search();
void* p = 0; int cnt = 0;
while ( p = it() )
        if ( e == p ) cnt++;  /// pointer comparison
return cnt;
}

dvlist_cell* dvlist_cell::remove(void* e) {
if ( e == el ) {
	_register(this);
	return next->remove( e );
	}
else next = next->remove(e);
return this;
}

void dvlist_cell::insert(void* e) { 
	if (!el) el = e;
	else if (!next) next = new dvlist_cell(e);
	else next->insert(e);
	}


class dvlistiter : public iter<void> {
public:
dvlistiter( dvlist_cell* c ) : iter<void>(this), p(c) {} 
~dvlistiter() {} 
virtual void* operator()() { 
        void* x = p?p->el:0;
        if (p) p = p->next;
        return x; 
        }
private:
dvlist_cell* p;
};

iter<void>* dvlist_cell::search() const {
       iter<void>* tmp = new dvlistiter((dvlist_cell*)this);
       ((dvlist_cell*)this)->_register(tmp);
       return tmp;
       } 

