// session.c --

#include <hush/session.h>

#include <hush/kit.h>
#include <hush/config.h>
#include <dv/tcl/callback.h>

#include <hush/assert.h>
#include <iostream.h>

#ifndef NOTIME
#include <sys/time.h>
#include <time.h>

static _inittime = 0;
static timeval inittime;
#endif

static session* _thesession;
session* thesession() { return ::_thesession; }
void thesession(session* s) { ::_thesession = s; }


session::session(session*) : _session(0), _clockval(0) { }

session::session(const char* mode) : _clockval(0) { // Incomplete
    _session = a_new_session("tcl",0,0,"mode",1);
    ::_thesession = this;
    tk = new class kit();
    _session->install(this);
    //cerr << "session " << _session << " from " << this << endl;
    promise ( tk && _session );
}


session::session(const char* mode, int _argc, char* _argv[],
		 const char* name, int flag) :
		 _clockval(0) 
{
    _session = a_new_session((char*)mode,_argc,_argv, (char*)name,flag);
    ::_thesession = this;
    tk = new class kit((char*)mode);
    _event = new tcl__event(tk,_argc,_argv);
    _session->install(this);
    //cerr << "session " << _session << " from " << this << endl;
    promise ( tk && _session );
}

session::session(int _argc, char* _argv[], const char* name, int flag) {
    _session = a_new_session("tcl",_argc,_argv,(char*)name,flag);
    ::_thesession = this;
    tk = new class kit();
    _event = new tcl__event(tk,_argc,_argv);
    _session->install(this);
    //cerr << "session " << _session << " from " << this << endl;
    promise ( tk && _session );
}

session::~session() { if (_session) delete _session; }

void session::init(const char* f, void* p) {
    if (_session) _session->init(f,p);
}


void session::install( void* p ) {
    require( p );
    require( _session != this );
    if (_session) _session->install(p);
}

void session::prelude() { }

int session::main() { 
	      //cerr << "WARNING: main undefined" << endl;
	      return 0;
	      }

void session::map(int fl) { if(_session) _session->map(fl); }

int session::loop(int fl) { return _session?_session->loop(fl):0; }

int session::body(int fl) { return _session?_session->body(fl):0; }


int session::run( int proc(class kit*,int,char**) ) {
    return _session?_session->run(proc):0;
}

double session::clock() const { return _clockval; }
double session::clock(double val) { 
    double tmp = clock();
    _clockval = val;
    return tmp;
}

double session::time() const {   // global inittime !!
    double curacttime = 0;
#ifndef NOTIME
    struct timeval tv;
    struct timezone tz;
    
    if (!_inittime++) gettimeofday(&inittime,NULL);
    // set actual starting time
    gettimeofday(&tv,&tz);
    const long delta_sec = tv.tv_sec - inittime.tv_sec;
    const long delta_usec = tv.tv_usec - inittime.tv_usec;
    curacttime =  (double) delta_sec + 
	(double) delta_usec / (double) 1000000L;
#endif
    return curacttime;
}

   

kit* session::thekit() const { return tk; }

int session::mode() const { return _session?_session->mode():0; }
int session::mode(int i) { return _session?_session->mode(i):0; }
int session::mode(const char* i) { return _session?_session->mode(i):0; }

