#ifndef _TCL_KIT_H
#define _TCL_KIT_H

#include <hush/kit.h>

extern void register_as(const char* path, const widget* w);

class tcl_kit : public kit {
static int n;
public:

char* info() const { return "tcl_kit"; }

tcl_kit(void*);
tcl_kit();
~tcl_kit();

int eval(const char* cmd);
char* evaluate(const char* cmd);

char* result() const;
void result(const char* s);

int source(const char* f);

int error(); /// NEW
void error(const char*); // NEW

void after(int n, const char* cmd="");
void after(int n, void*, void* = 0);
void after(int n, handler* h);

char* send(const char* it, const char* cmd);

char* selection(const char* options="") const;

void update(const char* options="");

int safe() const;
kit* slave(char* options = "");


void unbind(int fd);
void unbind(char* name, char* newname = "");

class action* action(const char* name);
class action* action(const char* name, handler* h);
class action* action(const char* name, void* proc , void* data = 0);

class action* action(handler* h);
class action* action(void* proc , void* data = 0);

class action* action(int fd, handler* h, int mask=readable); // jrvosse

void command(const char* name, void*, void*); /// NEW
void command(int fd, void*, void* =0, int mask=readable); 		          // jrvosse


void quit();

void trace(int i = 1);
void notrace();

event* get() const;

widget* root() const; 
widget* pack(class widget* w, const char* options = "-side top -fill x");
widget* pack(const char* w, const char* options = "-side top -fill x");


/// not for public use, will be changed to protected

int callback(void*,void*,int,char**);
void* interp() const; /// the interpreter, whatever it is
void* tkwin() const;  /// returns the root window
void put(event* p, int fl = 0); /// to update events

private:
char* buf;
int _trace;
void* _last;
int _type;
widget* _root;
void* _interp;
};



#endif
