//// dictionary.h -- dictionary(4),  (api/hush/dictinary.c)

#ifndef _DICTIONARY_H
#define _DICTIONARY_H

#include <hush/iter.h>

extern void set_dictionaryentry(void* p, void* v);
void* get_dictionaryentry(void* p);

//static dictionaryentry<void> dummy;


template<class T>
class dictionaryentry {
public:
dictionaryentry( void* p ) : _p(p) { }
T* operator=( T* v ) { set_dictionaryentry(_p,(void*)v); return (T*) v; }
operator T*() { return (T*) get_dictionaryentry(_p); }
private:
void* _p;
};


class rawdictionary {
public:
rawdictionary();
~rawdictionary();
void entry(char* k, void* v);
void* find(char* k);
void* del(char* k);

char* stats();
	
iter<void>* search();
void* operator()(char* k);

dictionaryentry<void>* operator[](char* k);
	
protected:
void* tbl;
};


//// The dictionary class:

template<class T>
class dictionary {
public:
dictionary() { d = new rawdictionary(); }
~dictionary() { delete d; }
void entry(char* k, T* v) { d->entry(k,v); }
T* find(char* k) { return (T*) d->find(k); }
T* del(char* k) { return (T*) d->del(k); }

char* stats() { return d->stats(); }
	
T* operator()(char* k) { return (T*) d->operator()(k); }

operator iter<T>() { return *(iter<T>*) d->search(); }

dictionaryentry<T>& operator[](char* k) {
	void* x = (*d)[k];
	return * (dictionaryentry<T>*) x;
	}
	
protected:
rawdictionary* d;
public:
iter<T> search() { return *(iter<T>*) d->search(); }
};

#endif
