//<h3>item.h</h3>
//An item is a bit like a widget, but it lives unlike a
//widget on a canvas, whereas a widget lives on the screen.
//However, a widget can be embedded in an item.
//<hr>
// item(4),
//<a href=hush.html>hush</a>,
//<a href=handler.h.html>handler.h</a>,
//<a href=kit.h.html>kit.h</a>,
//<hr>

//<ignore>
#ifndef ITEMS_H
#define ITEMS_H

#include <hush/handler.h>
class kit;
class action;

//</ignore>

class item : public handler {
public:
	item();
	item(const char*);
	item(item*);
	item(item&); /// copy constructor (should be const item&!)
	
	virtual ~item();
	
	virtual item& operator=(item&);  /// assignment (should be const item&!)

	
	virtual char* id() const ;
	virtual int no() const ; 
	
	operator int() const; /// calls no()
	
	item* operator ->(); /// non-virtual
	
	virtual void tag(const char* s);
	virtual char* tags() const;
	
	virtual void configure(const char* s);
	virtual void move(int x, int y);
	virtual void del();
	
	virtual int bind(const char* s, const char* cmd, const char* args = "" );
	virtual int bind(const char* s, handler* h, const char* args = "" );
	virtual int bind(const char* s, void* proc, void* c = 0, const char* args = "");
	virtual int bind(const char* s, action* a, const char* args = "" );
	
	/// For GNU's sake
	
	virtual int bind(class handler* h, const char* args = "" );
	virtual int bind(void* proc, void* data = 0, const char* args = "");
	virtual int bind(action* ac, const char* args = "" );
	
	virtual int direct(const char*s, action* ac, const char* args);

//<ignore>
#ifndef NOHANDLER
	virtual void handler(action* ac, const char* args = "" );
	virtual void handler(const char* cmd, const char* args = "");
	virtual void handler(void* proc, void* c = 0, const char* args = "" );
	virtual void handler(class handler* h, const char* args = "" );
#endif
//</ignore>

	virtual class widget* widget();


protected:
	virtual void install(action* ac, const char* args = "");
private:
	int _del;
	item* it;
};

//<ignore>
#endif
//</ignore>
