//<h3>session.h</h3>
//The session class is needed to start
//the X main loop.
//It is also used in the simulation package.
//<hr>
//<a href=hush.html>hush</a>,
//session(4), <hush/handler.h>
//<hr>

//<ignore>
#ifndef SESSION_H
#define SESSION_H

#include <hush/handler.h>
class kit;

//</ignore>

class session : public handler  {
    session(const char* = "tcl");
  public:
    session(const char* mode, int argc, char* argv[], 
	    const char* name = "hush", int fl=0);
    session(int argc, char* argv[], const char* name = "hush", int fl=0);
    // putting 0 for name disables window mapping	
    
    virtual ~session();
    
    virtual void prelude();
    virtual int main();
    
    virtual int run( int (*)(class kit*,int,char**) = 0 );
    
    //protected: // for experienced users only
    
    virtual void init(const char* fname, void* = 0);
    virtual void install(void* = 0);
    
    virtual int mode() const;
    virtual int mode(int fl);
    virtual int mode(const char* = 0);
    
    virtual int loop(int fl=0);
    virtual int body(int fl=0);
    
    virtual void map(int fl=0); // redefine map to disable window
    
    kit* thekit() const;
    
    virtual double clock() const;
    virtual double clock(double);
    
    virtual double time() const;
    virtual void time(double) { }
    
  protected:
    session(session*);
    //kit* tk;
  private:
    double _clockval;
    double _start;
    session* _session;
};

extern session* thesession();

extern void* theinterp();
extern void theinterp(void* x);

//<ignore>
#endif
//</ignore>
