// string.h --  (api/hush/string.c)

#ifndef DVSTRING_H
#define DVSTRING_H

#include <hush/iter.h>
#include <hush/list.h>

class event;

class dvstring {
public:

enum { plain = 0, argcv, pair }; /// modes

dvstring();
~dvstring();

dvstring(const char* s);  /// plain mode
dvstring(const dvstring& a);

dvstring(int argc, char** argv);  /// argcv mode
dvstring(const event*); /// to deal with argc/argv

dvstring& operator=( const dvstring& a );
dvstring& operator=( const char* a );

int operator==( const dvstring& a) const;
int operator==( const char* a) const;

dvstring operator+( const dvstring& a ) const;
dvstring operator+( const char* a ) const;

int length() const;
operator char*() const;

operator[](int i) const;  // ? mode dependent?

//<note name=argcv level=user>



int argc();
dvstring operator()(int i) { return arg(i); }

//<note mode=pair level=advanced>

int assoc(); // test and modify (changes to pair mode)
dvstring key(); // const -- yes, no maybe ? -- I don t know
dvstring value();

//<note mode=argcv level=advanced>

dvstring& flatten(int quote=0);
dvstring& quote() { return flatten(1); }

//<note level=system>
dvstring arg(int i = 1) ;

char** argv( int i = 0 );
int unflatten();

//// Iteration:

dvlist<dvstring>* split(const char* sp); /// on char s in sp

operator iter<dvstring>&();

private:
void* _body;
};

inline ostream& operator<<(ostream& os, const dvstring& str)
{
    os << (char*) str;
    return os;
}


#ifndef string
#define string dvstring
#endif

static iter<dvstring> dummy_iter_dvstring(0);


#endif
