#ifndef CANVAS_H
#define CANVAS_H

class handler;
class canvas; 

#include <hush/widget.h>
#include <hush/item.h>

extern canvas* thecanvas();
extern void thecanvas(canvas*);

class canvas : public widget {

public:
char* info() const { return "hush::canvas"; }
char* type() const;  /// canvas, what else

canvas() {}
canvas(const char *p, const char* options = "");
canvas(const widget* w, const char *p, const char* options = "");

void region(int x1, int y1, int x2, int y2 );

int canvasx(int screenx);
int canvasy(int screeny);

void install(action* ac, const char* args = "");

void tag(int id, const char* tag);
char* tags(int id);

void del(int id);
void del(const char* id);

void move(int id, int x, int y);
void move(const char* id, int x, int y);

item& bitmap(int x1, int y1, const char* bitmap, const char* options="");
void image(const char*) { } // to silence the compiler
item& image(int x1, int y1, const char* bitmap, const char* options="");
item& photo(int x1, int y1, int x2, int y2, const char* options ="");
void readppm(int id, const char* file ="");

item& line(int x1, int y1, int x2, int y2, const char* options ="");
item& line(const char* linespec, const char* options ="");
item& arc(int x1, int y1, int x2, int y2, const char* options ="");
item& oval(int x1, int y1, int x2, int y2, const char* options ="");
item& circle(int x1, int y1, int r, const char* options ="");
item& polygon(const char* linespec, const char* options ="");
item& rectangle(int x1, int y1, int x2, int y2, const char* options ="");
item& text(int x1, int y1, const char* txt, const char* options="");
item& window(int x1, int y1, const char* win, const char* options="");
item& window(int x1, int y1, widget* win, const char* options="");

/// obsolete or experimental

item& sphere(int x1, int y1, int x2, int y2, const char* color="white", const char* tag = "sphere", const char* options ="");
item& sphere(int x1, int y1, int r, const char* color="white", const char* tag = "sphere", const char* options ="");

/// item& methods

item& current();
item& overlapping(int x, int y, const char* options);
item& overlapping(int x, int y);

char* items(int x, int y);

void itemconfigure(int it, const char* options);
void itemconfigure(const char* tag, const char* options);

virtual itembind(int i, const char* s, action* a, const char* args = "" );
virtual itembind(const char *i, const char* s, action* a, const char* args = "" );

void postscript(const char* file, const char* options="");

protected:

virtual itemdirect(int i, const char *s, action* a, const char* args = "" );
virtual itemdirect(const char* i, const char *s, action* a, const char* args = "" );
};
#endif
