#ifndef LISTBOX_H
#define LISTBOX_H

#include <hush/widget.h>

class listbox : public widget {
  public:
    char* type() const ;
    
    listbox(const char* p, const char* options ="");
    listbox(const widget* w, const char* p, const char* options ="");
    
    virtual void insert(const char*);		// insert at end
    virtual void insert(int index, const char*);// insert at index

    virtual void del();				// delete all
    virtual void del(int index);		// delete one 
    virtual void del(int first, int last);	// delete range

    virtual void see(int index);		// make entry visible
 
    virtual char* get(int index) const;		// get entry 
    virtual int size() const;			// # entries

    virtual void select();			// select all
    virtual void select(int first, int last);	// select range
    virtual void unselect();			// unselect all
    virtual void unselect(int first, int last);	// unselect range

    virtual int selected(int index) const;	// true if entry selected
    virtual int selection() const;		// get index of (first) 
						//    selected entry
    // todo: geometry, scanning, selecting
    
    virtual void singleselect();
    
  protected: // virtual?
    void install(action* ac, const char* args );
    void init(const char* options);
};

#endif
