#ifndef MENU_H
#define MENU_H

#include <hush/widget.h>

class menu : public widget {
public:

char* type() const ;

menu() : widget() {}
menu(const char* p, const char* options = "");
menu(const widget* w, const char* p, const char* options = "");

menu* oldadd(const char* s, const char* options = "");

menu* entry(const char* s, action* ac, const char* args ="", const char* options = "");
menu* entry(const char* s, const char* args ="", const char* options = "");

menu* add(const char* s, action* ac, const char* args ="", const char* options = "");
menu* add(const char* s, const char* args ="", const char* options = "");

menu* checkbutton(const char* s, const char* args = "", const char* options = "");

menu* cascade(const char* s, const char* m, const char* options = "");
menu* cascade(const char* s, menu* m, const char* options = "");

char* entryconfigure(int i, const char* options);

int index(const char *s) const ;

int active() const;


void del(int i);
void del(const char* s);

char* invoke(int i);
char* invoke(const char *s);

void post(int x = 500, int y = 500);

void unpost();

protected:
char* _name;
char* _args;

void install(action* ac, const char* args);
};

#endif
