#ifndef XANIM_H
#define XANIM_H

#include <hush/widget.h>


class xanim : public widget {
public:

    char* type() const { return "xanim"; }

    c`xanim() : widget() { }
    xanim(const char* p, const char * options = "") : widget(p) {
	if (options) init(options);
    }

    xanim(const widget* w, const char* p, const char * options = "") : widget(w,p) {
	if (options) init(options);
    }

    ~xanim() {
	sprintf(buf,"%s quit",path());
	tk->eval(buf);
    }

/* If framenr = -1 then the last frame of the movie will be bound */
    void bind(int framenr, const char* cmd){
	sprintf(buf,"%s bind %d %s",path(),framenr,cmd);
	tk->eval(buf);
    }

    void xanim_bind(const char* cmd, int nr) { bind(nr,cmd); }
    void mpeg_bind(const char* cmd, int nr) { bind(nr,cmd); }

    void faster() {
	sprintf(buf,"%s faster",path());
	tk->eval(buf);
    }

    void forward() {
	sprintf(buf,"%s forward",path());
	tk->eval(buf);
    }

    void file(const char* s) {
	sprintf(buf,"%s file %s",path(),s);
	tk->eval(buf);
    }

    void normal() {
	sprintf(buf,"%s normal",path());
	tk->eval(buf);
    }

    void quit() {
	sprintf(buf,"%s quit",path());
	tk->eval(buf);
    }

/* If x = -1 and y = -1 then resize to the original size of the movie/image */
    void resize(int x,int y) {
	sprintf(buf,"%s resize %d %d",path(),x,y);
	tk->eval(buf);
    }

    void rewind() {
	sprintf(buf,"%s rewind",path());
	tk->eval(buf);
    }

    void slower() {
	sprintf(buf,"%s slower",path());
	tk->eval(buf);
    }

    void sound_on() {
	sprintf(buf,"%s sound on",path());
	tk->eval(buf);
    }

    void sound_off() {
	sprintf(buf,"%s sound off",path());
	tk->eval(buf);
    }

    void sound_louder() {
	sprintf(buf,"%s sound +",path());
	tk->eval(buf);
    }

    void sound_softer() {
	sprintf(buf,"%s sound -",path());
	tk->eval(buf);
    }

    void start() {
	sprintf(buf,"%s start",path());
	tk->eval(buf);
    }

    void step_next() {
	sprintf(buf,"%s step next",path());
	tk->eval(buf);
    }

    void step_prev() {
	sprintf(buf,"%s step prev",path());
	tk->eval(buf);
    }

    void stop() {
	sprintf(buf,"%s stop",path());
	tk->eval(buf);
    }

    void unbind(int framenr) {
	sprintf(buf,"%s unbind %d",path(),framenr);
	tk->eval(buf);
    }

    void unbind_all() {
	sprintf(buf,"%s unbindall",path());
	tk->eval(buf);
    }
};

//typedef xanim mpeg;

#endif
