all: lib

config:
test:

lib: $(SHARE)

list: $(OBJECTS)

shared: $(OBJECTS)
	rm -f $(LIB).so.* 
	$(LD) -o $(LIB).so.$(VERSION) $(OBJECTS) 

nonshared: $(OBJECTS)
	rm -f $(LIB).a
	ar cr $(LIB).a $(OBJECTS)
	$(RANLIB) $(LIB).a

install: lib 
	@echo -------- Installing $(LIB)  -- $(SHARE) -- in $(DEST)
	@if [ ! -d $(DEST)/lib ]; then mkdir $(DEST)/lib; fi
	@if [ $(SHARE) = "nonshared" ]; then \
		mv $(LIB).a $(DEST)/lib; \
		cd $(DEST)/lib; $(RANLIB) $(LIB).a; \
	else \
	mv $(LIB).so.$(VERSION) $(DEST)/lib; \
	set -x; cd $(DEST)/lib; \
	 rm -f $(LIB).so; ln -s $(LIB).so.$(VERSION) $(LIB).so; \
	fi;
	@echo ======== Installing $(LIB) completed == in $(DEST)

doc: index.html $(DOC) 
	@echo -------- Documenting $(LIB)  -- in $(DEST)
	@if [ ! -d $(DEST)/doc ]; then mkdir $(DEST)/doc; fi
	@if [ ! -d $(DEST)/doc/api ]; then mkdir $(DEST)/doc/api; fi
	@if [ ! -d $(DEST)/doc/api/$(NAME) ]; \
	    then mkdir $(DEST)/doc/api/$(NAME); fi
	cp index.html $(NAME).html
	cp  *.html $(DEST)/doc/api/$(NAME)
	if [ -f index.ps ]; then cp index.ps $(DEST)/doc/api/$(NAME); fi
	@echo ======== Documenting $(LIB) completed == in $(DEST)

cleandoc:
	rm -f core *.html *.dvi *.ps *.aux *.log *.tex

test:
demo:

clean: cleandoc
	rm -f core *.a *.o out *.out lib*.so.*  *.html
	rm -f -r Templates.DB
