#include <widgets/button.h>
#include <hush/action.h>

#include <iostream.h>
#include <string.h>

char* button::type() const { return "button"; }

button::button(const char* p, const char* options) : widget(p) { 
	if (options) init(options);
	}

button::button(const widget* w, const char* p, const char* options) : widget(w,p) {
	if (options) init(options);
	}


void button::text(const char* s) { 
	sprintf(buf,"%s configure -text \"%s\"",path(),s);
	tk->eval(buf);
	}

void button::bitmap(const char* s) { 
	if (s[0] != '@')
		sprintf(buf,"%s configure -bitmap @%s",path(),s);
	else
		sprintf(buf,"%s configure -bitmap %s",path(),s);
	tk->eval(buf);
	}

void button::image(const char* s) { 
	if (s[0] != '@')
		sprintf(buf,"%s configure -image %s",path(),s);
	else {
		sprintf(buf,"image create photo -file %s",s+1);
		char* r = tk->evaluate(buf);
		sprintf(buf,"%s configure -image %s",path(),r);
		}
	tk->eval(buf);
	}


void button::state(const char *s) {
	if (!strcmp(s,"normal") && !strcmp(s,"active") && !strcmp(s,"disabled") )
		cerr << "error: should be normal active or disabled" << endl;
	else {
		sprintf(buf,"%s configure -state %s",path(),s);
		tk->eval(buf);
		}
	}

void button::flash() {
	sprintf(buf,"%s flash",path());
	tk->eval(buf);
	}

char* button::invoke() {
	sprintf(buf,"%s invoke",path());
	return tk->evaluate( buf );
	}


void button::install(action* ac, const char* args) {
	sprintf(buf,"%s configure -command {%s %s}",path(),ac->name(),args);
	tk->eval( buf );
	}
