#include <widgets/checkbutton.h>
#include <string.h>


char* checkbutton::type() const { return "checkbutton"; }

checkbutton::checkbutton(const char* p, const char* options) : button(p,0) {
	if (options) init(options);
	}

checkbutton::checkbutton(const widget* w, const char* p, const char* options) : button(w,p,0) {
	if (options) init(options);
	}

void checkbutton::variable(const char* name) {
	_name = new char[strlen(name)+1];
	strcpy(_name,name);
	sprintf(buf,"%s configure -variable %s",path(), name);
	tk->eval( buf );
	}

int checkbutton::value() {
	int n = 0;
	if (_name) {
		sprintf(buf,"set %s",(char*) _name);
		sscanf(tk->evaluate( buf ),"%d",&n);
		}
	return n;
	}


void checkbutton::toggle() {
	sprintf(buf,"%s toggle",path());
	tk->eval( buf );
	}

void checkbutton::select() {
	sprintf(buf,"%s select",path());
	tk->eval( buf );
	}

void checkbutton::deselect() {
	sprintf(buf,"%s deselect",path());
	tk->eval( buf );
	}
