#include <hush/hush.h>
#include <widgets/entry.h>


char* entry::type() const { return "entry"; }

entry::entry(const char* p, const char* options) : widget(p) {
	if (options) init(options);
	}

entry::entry(const widget* w,const char* p, const char* options) : widget(w,p) {
	if (options) init(options);
	}

void entry::insert(const char* s) {
	sprintf(buf,"%s insert 0 \"%s\"",thepath(),s);
	tk->eval( buf );
	}

void entry::del() {
	sprintf(buf,"%s delete 0 end",thepath());
	tk->eval( buf );
	}


char* entry::get() {
	sprintf(buf,"%s get",thepath());
	return tk->evaluate( buf );
	}

void entry::install(action* ac, const char* args) {
	sprintf(buf," bind %s <Double-Button-1> {%s %s [%s get]}",thepath(),ac->name(), args, thepath());
	tk->eval( buf );
	bind("<Return>",ac,args);
	}
