#include <widgets/label.h>

char* label::type() const { return "label"; }

label::label(const char* p, const char * options) : widget(p) {
	if (options) init(options);
	}

label::label(const widget* w, const char* p, const char * options) : widget(w,p) { 
	if (options) init(options);
	}

#ifndef __GNUC__

void label::text(const char* s) { 
	sprintf(buf,"%s configure -text \"%s\"",thepath(),s);
	tk->eval(buf);
	}

void label::text(int value) {
        sprintf(buf,"%s configure -text %d", thepath(), value);
        tk->eval(buf);
        }
 
void label::text(long value) {
        sprintf(buf,"%s configure -text %ld", thepath(), value);
        tk->eval(buf);
        }


void label::text(double value, int precision) {
        sprintf(buf,"%s configure -text %-.*lf", thepath(), precision, value);
        tk->eval(buf);
        }

#endif
