#include <widgets/listbox.h>
#include <hush/action.h>

#include <stdlib.h>

char* listbox::type() const { return "listbox"; }

listbox::listbox(const char* p, const char* options) : widget(p) {
    if (options) init(options);
}

listbox::listbox(const widget* w, const char* p, const char* options) : 
widget(w,p) {
    if (options) init(options); 
}

void listbox::insert(const char* s) {
    sprintf(buf,"%s insert end \"%s\"",thepath(),s);
    tk->eval( buf );
}

void listbox::insert(int i, const char* s) {
    sprintf(buf,"%s insert %d \"%s\"",thepath(),i,s);
    tk->eval( buf );
}

void listbox::del() {
    sprintf(buf,"%s delete 0 end",thepath());
    tk->eval( buf );
}

void listbox::del(int i) {
    sprintf(buf,"%s delete %d",thepath(),i);
    tk->eval( buf );
}

void listbox::del(int first, int last) {
    sprintf(buf,"%s delete %d %d",thepath(), first, last);
    tk->eval( buf );
}

void listbox::see(int index) {
    sprintf(buf,"%s see %d",thepath(), index);
    tk->eval( buf );
}

char* listbox::get(int n) const {
    sprintf(buf,"%s get %d",thepath(),n);
    return tk->evaluate( buf );
}

int listbox::selection() const {
    sprintf(buf, "%s curselection", thepath());
    return atoi(tk->evaluate(buf));	// can be a list!
}

int listbox::selected(int index) const {
    sprintf(buf, "%s selection includes %d", thepath(), index);
    return atoi(tk->evaluate(buf));
}

void listbox::select() {
    sprintf(buf, "%s selection set 0 end", thepath());
    tk->eval(buf);
}

void listbox::select(int first, int last) {
    sprintf(buf, "%s selection set %d %d", thepath(), first, last);
    tk->eval(buf);
}

void listbox::unselect() {
    sprintf(buf, "%s selection clear 0 end", thepath());
    tk->eval(buf);
}
void listbox::unselect(int first, int last) {
    sprintf(buf, "%s selection clear %d %d", thepath(), first, last);
    tk->eval(buf);
}

int listbox::size() const {
    sprintf(buf, "%s size", thepath());
    return atoi(tk->evaluate(buf));
}

void listbox::singleselect() {
    sprintf(buf,"tk_listboxSingleSelect %s",thepath());
    tk->eval( buf );
}


void listbox::install(action* ac, const char* args ) {
    sprintf(buf," bind %s <Double-Button-1> { "
	"set indices [ %s curselection ] ; "
	"foreach i $indices {%s %s [ %s get $i ] }}"
	,thepath(), thepath(), ac->name(), args, thepath());
    tk->eval( buf );
}


void listbox::init(const char* options) {
    sprintf(buf,"listbox %s %s",path(),options);
    tk->eval(buf);


    // Change default behaviour ... is this ok ?
    // Anyway: my fileselector depends on this ...
    // jacco
    sprintf(buf,"bindtags %s { Listbox %s . all }", path(), path());
    tk->eval( buf );
}
