#include <widgets/radiobutton.h>
#include <string.h>

static char pname[BUFSIZ];

char* radiobutton::type() const { return "radiobutton"; }

radiobutton::radiobutton(const char* p, const char* options) : button(p,0) {
	strcpy(pname,p);
	if (options) init(options);
	}

radiobutton::radiobutton(const widget* w, const char* p, const char* options) 
						: button(w,p,0) {
	strcpy(pname,p);
	if (options) init(options);
	}

void radiobutton::variable(const char* name) {
	_name = new char[strlen(name)+1];
	strcpy(_name,name);
	sprintf(buf,"%s configure -variable %s",path(), name);
	tk->eval( buf );
	}

char* radiobutton::value() const {
	char* s = "";
	if (_name) {
		sprintf(buf,"set %s",(char*) _name);
		s = tk->evaluate( buf );
		}
	return s;
	}


void radiobutton::toggle() {
	sprintf(buf,"%s toggle",path());
	tk->eval( buf );
	}

void radiobutton::select() {
	sprintf(buf,"%s select",path());
	tk->eval( buf );
	}

void radiobutton::deselect() {
	sprintf(buf,"%s deselect",path());
	tk->eval( buf );
	}

void radiobutton::init(const char* options) {
	char* p = pname; if (*p == '.') p++;
	sprintf(buf,"%s %s -value %s %s",type(),
	  path(), p, options);
	tk->eval( buf );
	_name = new char[ strlen(path()+1)];
	strcpy(_name,path()); 
	}
