#include <widgets/scale.h>
#include <hush/action.h>

char* scale::type() const { return "scale"; }

scale::scale(const char* p, const char* options) : widget(p) { 
	if (options) init(options);
	}

scale::scale(const widget* w, const char* p, const char* options) : widget(w,p) {
	if (options) init(options); 
	}

void scale::text(const char* s) {
	sprintf(buf,"%s configure -label {%s}", path(), s);
	tk->eval( buf );
	}

void scale::from(int n) {
	sprintf(buf,"%s configure -from %d", path(), n);
	tk->eval( buf );
	}

void scale::to(int n) {
	sprintf(buf,"%s configure -to %d", path(), n);
	tk->eval( buf );
	}

int scale::get() {
	sprintf(buf,"%s get",path());
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return n;
	}

void scale::set(int v) {
	sprintf(buf,"%s set %d",path(),v);
	tk->eval( buf );
	}

void scale::install(action* ac, const char* args) {
	sprintf(buf,"%s configure -command {%s %s}",path(),ac->name(),args);
	tk->eval( buf );
	}
