#include <widgets/scrollbar.h>
#include <string.h>

char* scrollbar::type() const { return "scrollbar"; }

scrollbar::scrollbar(const char* p, const char* options) : widget(p) {
	if (options) init(options);
	}

scrollbar::scrollbar(const widget* w, const char* p, const char* options) : widget(w,p) {
	if (options) init(options);
	}


void scrollbar::xview(widget* w) {   /// to do *handler*  
	sprintf(buf,"%s configure -command {%s xview}",path(),w->path());
	tk->eval( buf );
	}

void scrollbar::yview(widget* w) {
	sprintf(buf,"%s configure -command {%s yview}",path(),w->path());
	tk->eval( buf );
	}

void scrollbar::command(widget* w, const char* option) {
	sprintf(buf,"%s configure -command \"%s %s\"",path(),w->path(),option);
	tk->eval( buf );
	}

void scrollbar::command(const char* w, const char* option) {
	sprintf(buf,"%s configure -command \"%s %s\"",path(),w ,option);
	tk->eval( buf );
	}

void scrollbar::orient(const char* option) {
	sprintf(buf,"%s configure -orient %s",path(),option);
	tk->eval( buf );
	}

void scrollbar::width(int n) {
	sprintf(buf,"%s configure -width %d",path(),n);
	tk->eval( buf );
	}
