#include <widgets/text.h>
#include <hush/action.h>

char* text::type() const { return "text"; }

text::text(const char *p, const char* options ) : widget(p) {
	if (options) init(options); 
	} 

text::text(const widget* w, const char *p, const char* options) : widget(w,p) {
	if (options) init(options); 
	} 

text::~text() { }

void text::insert(const char* s) {
	sprintf(buf,"%s insert insert \"%s\"",thepath(),s);
	tk->eval( buf );
	}

void text::insert(int l, int n, const char* s) {
	sprintf(buf,"%s insert %d.%d \"%s\"",thepath(),l,n,s);
	tk->eval( buf );
	}

void text::insert(const char* ind, const char* s) {
	sprintf(buf,"%s insert %s \"%s\"",thepath(),ind,s);
	tk->eval( buf );
	}

void text::del(const char* from, const char* to) {
        sprintf(buf, "%s delete %s %s", thepath(), from, to);
        tk->eval(buf);
}
 
void text::del(int fromline, int fromcol, int toline, int tocol) {
        sprintf(buf, "%s delete %d.%d %d.%d", thepath(), fromline, fromcol, toline, tocol);
        tk->eval(buf);
}




void text::install(action* ac, const char* args ) {
	sprintf(buf," bind %s <Double-Button-1> {foreach i [selection get] {%s $i %s}}",thepath(),ac->name(),args);
	tk->eval( buf );
	}
