#include <widgets/toplevel.h>

char* toplevel::type() const { return "toplevel"; }

toplevel::toplevel(const char* p, const char* options) : frame(p,0) { 
	if (options) init(options); 
	}

toplevel::toplevel(const widget* w, const char* p, const char* options) : frame(w,p,0) { 
	if (options) init(options);
	}

char* toplevel::title(const char* s) {
	sprintf(buf,"wm title %s \"%s\"",path(),s);
	return tk->evaluate( buf );
	}

void toplevel::transient(const char* w) {
	sprintf(buf,"wm transient %s %s",path(),w);
	tk->eval( buf );
	}

void toplevel::position() {
	sprintf(buf,"dpos %s",path());
	tk->eval( buf );
	}

void toplevel::init(const char* options) {
	widget::init(options);
	position();
	}
