//<html>
//<h2>Implementation: gui</h2>
//This file provides an implementation
//for the <a href=gui.h.html>gui</a> class.
//</html>

//<html>
//<h4>Includes</h4>
//</html>


#include <hush.h>
#include "gui.h"
#include "coffee.h"
#include "menu.h"
#include "help.h"

//<html>
//The <b>constructor</b>:
//</html>

gui::gui(kit* tk) {
 
    f = new frame(".screen");

    menubar* bar = new menubar(f,".bar");
    bar->pack();

    canvas* c = new canvas(f,".canvas","-bg black");
    c->configure("-height 400 -width 200");

    c->rectangle(20,150,180,250,"-fill lightblue");

    button* s = new button(c,".s","-bg blue -fg white");
    s->text("25ct");

    c->window(140,40,s);      // button needs not to be packed
    c->pack();

    s->bind( new coffee_handler(c) );

    f->pack(bar)->pack(c)->pack(".quit");

    menubutton* b = new menubutton(bar,".b1");
    b->text("commands");
    b->pack("-side left -fill x");

    menu* m = new menu(b,".m");
    m->bind(new menu_handler(c));         
    b->menu(m);

    m->entry("refill");
    m->entry("money back");
    m->entry("quit","quitting","-command { destroy . }");

    button* help = new button(bar,".help");
    help->text("help");
    help->bind(new help_handler("help.ht"));
    help->pack("-side right -fill x");

    f->pack();
}

//<html>
//<h4>Comments</h4>
//The function of the gui class is, indeed,
//to create a graphical user interface.
//</html>

//<html>
//<hr><address>se@cs.vu.nl</address>
//</html>
