HUSH = /home/eliens/dv/hush
CC = CC -PIC

TKLIBS =  -lsafe -ltk -ltcl
HUSHLIBS = -lhush -lwidgets -ldv
CONTRIBLIBS = 

SYSTEMFLAGS = -I/usr/openwin/include
SYSTEMLIBS = -R/usr/openwin/lib -L/usr/openwin/lib -lX11 -lm -lsocket -lnsl -ldl

##<html>
##<hr>
##<h4>Compiler and load flags</h4>
##The resource.mk file sets a number of variables
##and target descriptions needed in the
##<a href=Makefile.html>makefile</a>.
##<hr>
##</html>

LOCAL = .
LIBDIRS = -L$(LOCAL) -R$(LOCAL) -L$(HUSH)/lib -R$(HUSH)/lib

CFLAGS = -I$(LOCAL)  -I$(HUSH)/include $(SYSTEMFLAGS)
LDFLAGS = $(LIBDIRS) $(HUSHLIBS) $(TKLIBS) $(SYSTEMLIBS)

##<html>
##<hr>
##<h4>Suffixes</h4>
##Targets are recognized by their file-suffixes,
##as defined below.
##<hr>
##</html>

.SUFFIXES: .h .c .mk .ps .html .c.html .h.html .mk.html .out

##<html>
##<hr>
##<h4>Dependencies</h4>
##The definitions for the dependencies between targets are given below.
##<hr>
##</html>

.h.h.html:
	cc-html.flt < $*.h > $*.h.html

.c.c.html:
	cc-html.flt < $*.c > $*.c.html

.mk.mk.html:
	cc-html.flt < $*.mk > $*.mk.html

.html.ps:
	html-latex.flt < $*.html > $*.tex
	latex $*
	dvips < $*.dvi > $*.ps

.c.out:
	$(CC) -o $*.out $*.c $(CFLAGS) $(LDFLAGS) 


