#include <hush.h>
#include "tablet.h"

#include "draw_handler.h"
#include "move_handler.h"
#include "box_handler.h"
#include "circle_handler.h"
#include "arrow_handler.h"

#include <string.h>

tablet::tablet(const widget* w, const char* options) : /// \fbox{$tablet::tablet$}
	       canvas(w,"tablet",0) { /// (a)
	widget* top = new frame(path());
	init(options);
	redirect(c); /// (b)
	bind(this); /// (c)
	handlers[drawmode::draw] = new draw_handler(this);
	handlers[drawmode::move] = new move_handler(this);
	handlers[drawmode::box] = new box_handler(this);
	handlers[drawmode::circle] = new circle_handler(this);
	handlers[drawmode::arrow] = new arrow_handler(this);
	_mode = drawmode::draw;
	}


int tablet::mode(const char* s) {
int m = -1;
if (!strcmp(s,"draw")) m = drawmode::draw;
if (!strcmp(s,"move")) m = drawmode::move;
if (!strcmp(s,"box")) m = drawmode::box;
if (!strcmp(s,"circle")) m = drawmode::circle;
if (!strcmp(s,"arrow")) m = drawmode::arrow;
if (m >= 0) _mode = m;
cerr << "MM: " << s << "->" << _mode << endl;
return m;
}

void tablet::init(const char* options) {

c = new canvas(this,".canvas",options);
c->configure("-relief sunken -background white");
c->geometry(200,100);
c->region(0,0,800,800);

scrollbar* scrollx = new scrollbar(this,".scrollx");
scrollx->orient("horizontal");
scrollx->pack("-side bottom -fill x");

scrollbar* scrolly = new scrollbar(this,".scrolly");
scrolly->orient("vertical");
scrolly->pack("-side right -fill y");

c->pack();

c->xscroll(scrollx); scrollx->xview(c);
c->yscroll(scrolly); scrolly->yview(c);
}
