#include "hush.h"

class compound : public item {
public:

compound( canvas* cv ) : c(cv) {

    c->geometry(100,100);
    c->configure("-bg grey");

    it[0] = c->text(0,0,"SOME TEXT","-fill black -anchor e");
    it[1] = c->circle(10,10,40,"-fill yellow");
    it[2] = c->circle(20,20,30,"-fill red");
    it[3] = c->circle(40,40,20,"-fill blue");
    it[4] = c->circle(50,50,10,"-fill green");
    it[5] = c->text(60, 60,  "MOVE TEXT", "-fill black -anchor w");

    moving = 0;

    for ( int i = 0; i <= 5 ; i++ ) {
	it[i]->tag("compound");
    	it[i]->bind(this);
        if ( ! (i == 0 || i == 5) )
		it[i]->configure("-stipple {@example_p.bm}");
        }

    }

void press( event& e) {
	x = e.x(); y = e.y();
	id = c->overlapping(x, y, "first");
	//cout << id->tags()  << endl;
	if (id) moving = 1;
	}

void motion( event& e ) {
	if (moving) {
		c->move("compound", e.x() - x, e.y() - y );
		x = e.x(); y = e.y();
		}
	}

void release( event& ) { moving = 0; }

protected:
canvas* c;
int x,y;
int moving;
item id;
item it[12];
};


class application : public session {
public:
application(int argc, char** argv) : session(argc,argv,"compound") {}

int main() {
 
    // tk->trace();

    canvas* c = new canvas(".canvas");
    item* x = new compound(c);

    tk->pack(c);
    tk->pack(".quit");

    return OK;
}
};

int main (int  argc, char  **argv) {
    session* s = new application(argc,argv);
    return s->run();
}
