#include "hush.h"

class item_handler : public handler {
public:

item_handler( item i, canvas* cv ) : id(i), c(cv) {
	moving = 0;
	}

void press( event& e) {
	x = e.x(); y = e.y();
	if (id) moving = 1;
	}

void motion( event& e ) {
	if (moving) {
		id->move( e.x() - x, e.y() - y );
		x = e.x(); y = e.y();
		}
	}

void release( event& ) { moving = 0; }

protected:
canvas* c;
int x,y;
int moving;
item id;
};


class application : public session {
public:
application(int argc, char** argv) : session(argc,argv,"item") {}

int main() {
 
    tk->trace(7);

    canvas* c = new canvas(".canvas");

    item i1 = c->oval(120,60,180,180,"-fill blue");
    item i2 = c->image(100,100,"@test2.gif");
    item i3 = c->bitmap(140,140,"@bishop.bm");

    handler* h1 = new item_handler(i1,c);
    handler* h2 = new item_handler(i2,c);
    handler* h3 = new item_handler(i3,c);

    i1->bind(h1);
    i2->bind(h2);
    i3->bind(h3);

    tk->pack(c);
    tk->pack(".quit");
    return OK;
    }
};

int main (int  argc, char  **argv) {
    session* s = new application(argc,argv);
    return s->run();
}
