#include <hush.h>

class canvas_handler : public handler {
public:

canvas_handler( canvas* cv ) { c = cv; moving = 0; }

void press( event& e) {
	x = e.x(); y = e.y();
	id = c->overlapping(x, y, "first");
	if (id) moving = 1;

	char* all = c->items(x,y);
	cout << "overlapping items " << all << endl;
	}

void motion( event& e ) {
	if (moving) {
		id.move( e.x() - x, e.y() - y );
		x = e.x(); y = e.y();
		}
	}

void release( event& ) { moving = 0; }

protected:
canvas* c;
int x,y;
int moving;
item id;
char buf[BUFSIZ];
};


class application : public session {
public:
application(int argc, char** argv) : session(argc,argv,"items") {}

int main() {
 
    tk->trace(7);

    canvas* c = new canvas(".canvas","-height 400 -width 600");
    c->bind(new canvas_handler(c)); /// this is gnu for handler

    c->bitmap(30,50,"@king.bm");
    c->image(50,80,"@test2.gif");
    c->oval(20,40,40,80,"-fill red");
    c->oval(120,60,180,180,"-fill blue");
    item it = c->oval(10,10,70,70,"-fill green");
    it->configure("-stipple {@example_p.bm}");
    c->image(120,60,"@laplace.gif");

    c->text(80, 80,  "City:", "-fill black -anchor e");
    c->text(80, 100,  "City:", "-fill black -anchor w");

    int i = c->image(400,150,"@teapot.ppm");


    c->bitmap(550,350,"@king.bm");

    c->line("10 20 30 30 100 100 80 80 550 350","-smooth 1");

    tk->pack(c);
    tk->pack(".quit");
    return OK;
    }
};

int main (int  argc, char  **argv) {
    session* s = new application(argc,argv);
    return s->run();
}
