#include <hush.h>
#include <hush/dictionary.h>

class app {
int n;
public:
app(int i = 0) { n = i; }
app(app& a) { n = a.n; }

int value() { return n; }
};

ostream& operator<<(ostream& o, app& it) {
o << " " <<  it.value() << " ";
return o;
}


int main(int, char**) {

    app i1(1);
    app i2(2);

    dictionary<app> t;

    t["app1"] = &i1;
    t["app2"] = &i2;
    t["app3"] = &i2;

    t["app4"] = &i1;
    t["app5"] = &i2;
    t["app6"] = &i2;

    app n1 =  *t["app1"];
    app n2 =  *t["app2"];

    cout << "dictionary " << n1  << n2 << endl;
    app* ap2 = t["app5"];
    cout << "also  " << *t["app4"] << *ap2 << endl;

    iter<app> it = t; // obtain iter by assignment;
    app* ip;
    while( ip = it() ) { // delivers pointer to app object
	cout << *ip << endl;
	}

    iter<app> it1 = t; // idem
    while( ip = it1() ) {
	cout << *ip << endl;
	}

    cout << t.stats() << endl; // print statistics
    return 0;
}
