// I lied about events

#include <hush.h>
#include <stdlib.h>

class ping  : public event {  /// isa handler
int max;
int n;
public:
ping(char* s, int k = 10) : max(k), event(s) { n = 0; }
int operator()() { 
  cout << "event:" << name() << " "  << n++ << endl;
  if (n < max) process();
  return 1;
}
};

class ev_handler : public handler {
public:
int operator()() {
  cerr << "Execute: ";
  event& e = *tk->get();
  cerr <<  e.name() << " " << e.eventclass() <<  endl;
  return e();
  }
};



class application : public session {
public:
application(int _argc, char* _argv[]) : session(_argc,_argv,0) {}

void map(int){ } // to disable window mapping

int main() {
	
	tk->trace();

	handler* h = new ev_handler; // executes events !!
	tk->action("do-it",h);

	event* e1 = new ping("kwik");
	event* e2 = new ping("kwek");
	event* e3 = new ping("kwak");

	e1->dependent(e2);
	e1->dependent(e3); 
	e2->dependent(e3); 

	if (e1->contains(e3)) cerr << "\nMULTIPLE e3" << endl;

	tk->put(e1);
	event* e = tk->get();

	cerr << "Start with: " << e->name() << ":: " << e->eventclass() << endl; 

	tk->eval("do-it");

	e1->remove(e3);
	tk->eval("do-it");


	tk->put(e2);
	e = tk->get();

	cerr << "Continue with: " << e->name() << endl; 

	tk->eval("do-it");

	tk->put(e3);

	if (e1->contains(e3) || e3->contains(e1))  // circularity ?
		cerr << "CIRCULARITY" << endl;
	else
		e3->dependent(e1); 

	tk->eval("do-it");

	e1->remove(0); // removes all!
	e3->dependent(e1);

	tk->eval("do-it");

	return OK;

}

};

int main(int argc, char* argv[]) {
session* s = new application(argc,argv);
return s->run();
}

