#include "hush.h"
#include "math.h"

double newton(double arg) {   /// [1]
double r = arg, x = 1, eps = 0.0001;
while( fabs(r - x) > eps ) {
	r = x;
	x = r - ( ( r * r - arg ) / ( 2 * r ));
	}
return r;
}

char fbuf[56];
char* ftoa( double f) { sprintf(fbuf,"%f",f); return fbuf; }

class generator : public handler {   /// [2]
public:

generator() {
	s = (scale*) new widget(".s");
	m = (message*) new widget(".m");
	}

~generator() {
	s->destroy();
	m->destroy();
	}

int operator()() {
	cout << s->get() << endl;
	float f = s->get();
	m->text( ftoa( newton(f) ) );
	return OK;
	}

private:
scale* s; message* m;
};

class application : public session { /// [3]
public:
application(int argc, char* argv[] ) : session(argc, argv,"newton") { }

int main() {
    tk->trace();
    
    tk->source("interface.tcl");
    generator* g = new generator();

    tk->action("generate",g);
    tk->pack(".quit");
    return OK;
    }
};


int main (int  argc, char  **argv) { /// [4]
    session* s = new application(argc,argv);
    return s->run();
}

