
#include <hush/list.h>
#include <iostream.h>


// The << operator must be defined by the user!
// for Sun CC because of linking problems

#ifdef __SUNPRO_CC
ostream& operator<<(ostream& os, list<int>& l) {
l.print(os);
return os;
}

ostream& operator<<(ostream& os, list< list<int> >& l) {
l.print(os);
return os;
}
#endif

// The format functions may be defined by the user.

static ostream& e_format(ostream& os, int* p ) {
os << "EL: " << *p << endl;
return os;
}

static ostream& l_format(ostream& os, list<int>* p ) {
os << "LIST: " << *p << endl;
return os;
}

// Ignore these if you're not interested in higher level programming

static int summit(int* p) { /// for process
	return *p;
	}

static int summit(list<int>* p) { /// for apply
	return p->process( summit );
	}

static int* imappit(int* p) { /// for map
	*p += 1;
	return p;
	}

static int* mappit(int* p, list<int>* l) {
	*p += l->process(summit);
	return p;
	}

static list<int>* doit(int* p, list<int>* l) { /// for apply
	list<int>* x = l->clone();  /// intermediate list
	l->_register(x); ////////////// for garbage collection
	list<int>* y = x->map( imappit );
	return y;  /// y will beregistered automatically
	}

// Now pay attention again, and look at the main function

int main(int argc, char** argv) {

list<int> l;
int i1 = 1; int i2 = 2; int i3 = 3;

l.insert(&i1); l << &i2 << &i3;
l.format(e_format);

int sum = 0;

iter<int> it = l;  // convert to iter by assignment
int* pn = 0;
while ( pn = it() ) {
	sum += *pn;
	}
//cout << "TOTAL: " << sun << " (nonsense!)" << endl;  ///  sun is ...
cout << "LIST: " << l << "TOTAL: " << sum << endl;  /// this is right


// The rest is more advanced stuff


cout << "TOTAL SUM: " << l.process( summit ) << endl;
list<int>* l1 = l.map(imappit);    // gets format from l
cout << *l1 << endl;
cout << "TOTAL SUM: " << l1->process( summit ) << endl;
list<int>* l2 = l.map(mappit);
cout << *l2 << endl;
cout << "TOTAL SUM: " << l2->process( summit ) << endl;;

#ifdef might_be_recursive
list< list<int> >* l3 = l.apply(doit);
l3->format( l_format );
cout << *l3 << endl;
cout << "TOTAL SUM: " << l3->process( summit ) << endl;
#endif

/// deletion of lists generated from is list is done automaticcally
return 0;

}
