//<h3>Example -- meta.c</h3>
//Demonstrates how to make a compound or meta widget.
//Remark: this solution differs from the way
//compound widgets were created for hush-1.5 (Tk3.6)
//due to a change of widget registration in Tk4.0.

#include <hush.h>
#include <string.h>

class meta : public button {
public:

meta() { }  // to create "meta" command handler

meta(char* p, char* options="") : button(p,0) {  // 0 to avoid creation
	if (options) init(options);
	}

meta(widget* w, char* p, char* options="") : button(w,p,0) {
	if (options) init(options);
	}

int operator()() {
	int argc = _event->argc(); char** argv = _event->argv();
	if (!strcmp("self",argv[1])) tk->result(self()->path());
	else if (!strcmp("meta",*argv)) create(--argc,++argv);
	else self()->eval( quote(--argc,++argv) );
	return OK;
	}
private:

void create(int argc, char* argv[]) {
	char* name = *argv;  // don't omit name !
	new meta(name, quote(--argc,++argv));
	}

void init(const char* options) {
	widget* root = new frame(path(),"-class Meta");
	button* b = new button(root,".button",options);

	b->pack(); // pack inner widget

	redirect( b );  // the widget of interest

	alias( this );  // to install the widget command
	}
};


class application : public session {
public:
application(int argc, char* argv[]) : session(argc,argv) {}
int main() {
    tk->trace();
    
    tk->action("meta", new meta); // 'meta' command handler
    tk->source("meta.tcl");

    //tk->pack(".quit");
    return OK;
    }
};

int main(int argc, char* argv[]) {
session* s = new application(argc,argv);
s->run();
return 0;
}
