#include "hush.h"

static int donit = 0;

class canvas_handler : public handler {
public:

canvas_handler( canvas* cv ) { c = cv; moving = 0; }

void press( event& e) {
	x = e.x(); y = e.y();
	id = c->overlapping(x, y);
	if (id) moving = 1;
	donit = 1;
	}

void motion( event& e ) {
	if (moving) {
		id.move( e.x() - x, e.y() - y );
		x = e.x(); y = e.y();
		}
	}

void release( event& ) { moving = 0; donit = 0; }

protected:
canvas* c;
int x,y;
int moving;
item id;
};


class application : public session {
public:

application(int argc, char** argv) : session(argc,argv,"session") {

this->mode("dont_wait");     /// busy waiting -- not the nicest solution
}

int main() {
	_time = clock();             // first time 0
        
	tk->trace();
	
	canvas* c = new canvas(".canvas");
	c->bind(new canvas_handler(c));
	c->oval(120,60,180,180,"-fill blue");
	c->bitmap(100,100,"@test2.gif");
	c->bitmap(140,140,"@bishop.bm");
	c->pack();
	
	tk->pack(".quit"); 
	return OK;
	}

int body(int fl = 0) {      // to break in X-loop, you may redefine session::loop
if (donit) {
       _time += 1.1;
       clock(_time);
       cout << "Done it at " << clock();
       cout << " (" << time() << ")" << endl;
       }
return fl;
}

private:
double _time;
};



int main (int argc, char* argv[]) {
session* s = new application(argc,argv);
s->run();
cerr << "End of Run" << endl;
}
