#include <hush/string.h>
#include <hush/list.h>
#include <iostream.h>

// run with string.out x=2 y=" another thing "

int main(int argc, char** argv) {

// argc, argv handling

cout << argc << " " << argv[0] << endl;
string args(argc,argv);
cout << args.argc() << " " << (char*)args(0) << endl;
cout << (char*) args << endl;

// !strcmp -> ==

int i = 0;
while ( i < args.argc() ) {
    string s = args(i);
    if ( s == "string.out" ) cout << "OK" << endl;
    else if (s.assoc()) {
	cout << (char*) s << endl;
	if ( s.key() == "x" )
		cout << s.key() << "= " << s.value();
     }
     i++;
  }

// key=value pair handling (might be nice instead of -key value )
// must be improved though

string attribute = "akey={ some \"strange { value }\" ---}";
if (attribute.assoc()) 
       cout << attribute.key() << ":: " << attribute.value() << endl;


// iter mode for args
iter<string> sit = args; // coercion by assignment
string* sp = 0;
while ( sp = sit() )
	cout << "from iter: " << *sp << endl;

// splitting
cout << "Splitting on /" << endl;
string s2 = "a:b:aa/bb:aaa::bbb://abc";  
s2.split("/");  // removes double occurrences !
sit = s2; // (reuse) iter by assignment
while ( sp = sit() ) {
	cout << "from iter: " << *sp << endl;
	}

cout << "Splitting on :" << endl;
string s3 = s2;
s3.split(":/");  // removes double occurrences !
sit = s3; // iter by assignment
while ( sp = sit() ) {
	cout << "from iter: " << *sp << endl;
	}

return 0;
}
