//<html>
//<h3>Program -- dialog (with grab)</h3>
//</html>

#include "hush.h"
#include <string.h>

class text_handler : public handler {    // to test grab
public:
text_handler(text* t) : _text(t) {} 
int operator()() {
	cerr << "This handler is not active during a grab" << endl;
	return OK;
	}
private:
text* _text;
};

class dialog : public toplevel {
public:
dialog(text* t) : _text(t), toplevel(gensym()) {

	 message* m = new message(this,".message");
	 m->text("Type your answer");
         
	 _entry = new entry(this,".entry","-relief sunken");
	   
         frame* f = new frame(this,".frame");

	 button* b = new button(f,".ok");
	 b->text("OK");
	 b->bind(this,"OK");

	 button* c = new button(f,".cancel");
	 c->text("cancel");
	 c->bind(this,"cancel");
	  
	 c->pack("-side left -fill x");
	 b->pack("-padx 5 -side right -fill x -fill y");

         tk->pack(m)->pack(_entry)->pack(f);

	 _entry->focus();  /// to attract the focus
	 grab();      /// grabs all action
	 }

void ok() { _text->insert( _entry->get() ); destroy(); }
void cancel() { destroy(); }

int operator()() {
	int argc = _event->argc(); char** argv = _event->argv();
	if (!strcmp(argv[1],"OK")) this->ok();
	else if (!strcmp(argv[1],"cancel")) this->cancel();
	return OK;
	}
protected:
text* _text;
entry* _entry;
};

class interact : public handler {
public:
interact(text* t) : _text(t) {}
int operator()() {
	widget* d = new dialog(_text);
	return OK;
	}
private:
text* _text;
};

//// The application class:

class application : public session {
public:
application(int argc, char* argv[]) : session(argc,argv,"dialog") { }

int main() {
    tk->trace();

    ::button* b = new ::button(".b");
    b->text("click");

    text* t = new text(".t");

    t->insert("Some text");
    t->bind("<Return>", new text_handler(t)); // to test grab

    b->bind(new interact(t));
    b->pack();
    t->pack();

    tk->pack(".quit");
    return OK;
    }

};


//// The main function:

int main (int  argc, char  **argv) {
session* s = new application(argc,argv);
return s->run();
}
