//<html>
//<h3>Program -- doublelistbox</h3>
//</html>

#include "hush.h"
#include <string.h>

void new_window(kit* tk);

class menu_handler : public handler {
public:
int operator()() {
	 int argc = _event->argc(); char** argv = _event->argv();
	 if (!strcmp(argv[1],"scroll")) {
		new_window(tk);
		}
	 else if (!strcmp(argv[1],"quit")) {
		tk->quit();
		if (argc > 2) cout << argv[2] << endl;
		}
	 else {
		cout << argv[1] << endl;
		widget* w = new widget(argv[1]);
		w->destroy();
		delete w;
		}
	 return OK;
	 }
};


void new_window(kit* tk) {

    toplevel* f = new toplevel( ".top" );

    listbox* l1 = new listbox(f,".list1");
    listbox* l2 = new listbox(f,".list2");

    l1->configure("-geometry 10x5");
    l2->configure("-geometry 10x5");

    l1->bind(new menu_handler(), f->path());
    l2->bind(new menu_handler(), f->path());
    l1->pack("-side left");
    l2->pack("-side left");

    l1->insert("hallo1");
    l2->insert("hello2");
    l1->insert("hallo1");
    l2->insert("hello2");
    l1->insert("hallo1");
    l2->insert("hello2");
    l1->insert("hallo1");
    l2->insert("hello2");
    l1->insert("hallo1");
    l2->insert("hello2");
    l1->insert("hallo1");
    l2->insert("hello2");
    l1->insert("hallo1");
    l2->insert("hello2");
    l1->insert("hallo1");
    l2->insert("hello2");

    scrollbar* s = new scrollbar(f,".scroll");
    s->pack("-side left -fill y");

    //s->yview(l1); --> to be replaced by
    char buf[BUFSIZ];
    sprintf(buf,"proc view {x} { %s yview $x; %s yview $x }",
	 				l1->path(), l2->path());
    tk->eval( buf );

    s->configure("-command view");

    l1->yscroll(s);
    l2->yscroll(s);
}



//// The application class:

class application : public session {
public:
application(int argc, char* argv[]) : session(argc,argv,"scrollwindow") {}
int main() {
    tk->trace();

    menubutton* b = new menubutton(".b");
    menu* m = new menu(b,".m");  
    b->menu(m);
    b->text("menu");

    m->bind(new menu_handler());

    m->entry("scroll");
    m->entry("quit");

    b->pack();
    tk->pack(".quit");
    return OK;
    }
};

//// The main function:

int main(int argc, char* argv[]) {
session* s = new application(argc,argv);
return s->run();
}
