//<html>
//<h3>Program -- interact</h3>
//</html>

#include "hush.h"
#include <string.h>

void new_window(kit* tk);

class menu_handler : public handler {
public:
int operator()() {
	 int argc = _event->argc(); char** argv = _event->argv();
	 if (!strcmp(argv[1],"scroll")) {
		new_window(tk);
		}
	 else if (!strcmp(argv[1],"quit")) {
		tk->quit();
		if (argc > 2) cout << argv[2] << endl;
		}
	 else {
		cout << tk->selection() << endl;
		widget* w = new widget(argv[1]); /// see (**)
		w->destroy();
		delete w;
		}
	 return OK;
	 }
};


void new_window(kit* tk) {

    toplevel* f = new toplevel( ".top" );

    listbox* l = new listbox(f,".list");
    l->bind(new menu_handler(), f->path()); //// (**)
    l->pack("-side left");

    l->insert("hallo1");
    l->insert("hello2");

    scrollbar* s = new scrollbar(f,".scroll");
    s->pack("-side right -fill y");

    s->yview(l);
    l->yscroll(s);
}



//// The application class:

class application : public session {
public:
application(int argc, char* argv[]) : session(argc,argv,"scrollwindow") {}
int main() {
    tk->trace();

    menubutton* b = new menubutton(".b");
    menu* m = new menu(b,".m");  
    b->menu(m);
    b->text("menu");

    m->bind(new menu_handler());

    m->entry("scroll");
    m->entry("quit");

    b->pack();
    tk->pack(".quit");
    return OK;
}
};


//// The main function:

int main(int argc, char* argv[]) {
session* s = new application(argc,argv);
return s->run();
}
