//<html>
//<h3>Program -- keys</h3>
//</html>

#include "hush.h"

class canvas_handler : public handler {
public:

canvas_handler( canvas* cv ) { c = cv; moving = 0; }

void press( event& ) { moving = 1; }

void motion( event& e) {
	if (moving) c->circle(e.x(),e.y(),3,"-fill black");
	}

void release( event&  ) { moving = 0; }

void keypress( event& e ) {
	int argc = _event->argc(); char** argv = _event->argv();
	if (argc >= 1) cout << argv[1] << endl;
	cout << " pressing " << e.keycode() << endl;
	}

void keyrelease( event& e ) {
	int n = e.keycode();
	char buf[BUFSIZ];
	sprintf(buf," %d %c %x %o ", n, n, n, n );
	cout << " releasing " << buf << endl;
	}

void other( event& e ) {
	cout << " other " << e.keycode() << endl;
	}


protected:
canvas* c; int moving; 
};


//// The application class:

class application : public session {
public:
application(int argc, char** argv) : session(argc,argv,"keys") {}

int main() {
 
    tk->trace();

    canvas* c = new canvas(".canvas");
    handler* h = new canvas_handler(c);
    c->bind(h);
    c->bind("<KeyPress-a>",h,"a");
    c->bind("<Control-KeyPress-c>",h,"Control-C");
    c->bind("<Shift-KeyPress-f>",h,"Shift-F");
    c->bind("<KeyRelease>",h);
    c->focus();

    tk->pack(c);
    tk->pack(".quit");
    return OK;
    }
};

//// The main function:

int main (int  argc, char  **argv) {
    session* s = new application(argc,argv);
    return s->run();
}
