//<html>
//<h3>Program -- menubar</h3>
//</html>

#include "hush.h"
#include <string.h>

class menu_handler : public handler {
public:

menu_handler(menu* m) : _m(m) { }

int operator()() {
	 int argc = _event->argc();
	 char **argv = _event->argv(); 
	 int n = _m->active();
	 cout << "entry " << n <<  endl;
	 if ( argc > 0 && !strcmp(argv[1],"quit")) {
		tk->quit();
		if (argc > 2) cout << argv[2] << endl;
		}
	 return OK;
	 }
private:
menu* _m;
};


//// The application class:

class application : public session {
public:
application(int argc, char** argv) : session(argc,argv,"menubar") {}

int main() {

    tk->trace();

    menubar* bar = new menubar(".bar");

    menubutton* b1 = new menubutton(bar,".b1");
    b1->text("one");

    menubutton* b2 = new menubutton(bar,".b2");
    b2->text("two");

    menu* m1 = new menu(b1,".m");  // must be a descendent of menubutton
    b1->menu(m1);

    menu* m2 = new menu(b2,".m");  // must be a descendent of menubutton
    b2->menu(m2);

    m1->bind(new menu_handler(m1));
    m2->bind(new menu_handler(m2));

    m1->entry("zero");
    m1->entry("one");

    m2->entry("second");
    m2->entry("third");

    menu* m3 = new menu(m2,".m");  // must be a descendent of menubutton
    m3->bind(new menu_handler(m3));

    m3->entry("fifth");
    m3->entry("sixth");

    m2->cascade("fourth",m3);

    bar->append(b1);
    bar->append(b2);

    tk->pack(bar);
    tk->pack(".quit");
    return OK;
    }
};


//// The main function:

int main (int  argc, char  **argv) {
    session* s = new application(argc,argv);
    return s->run();
}
