//<html>
//<h3>Program -- numbers</h3>
//</html>

#include <math.h>
#include "hush.h"

// screen layout

const int MAX = 500;
const int unit = 50;
const width = 600;
const height = 400;

// dynamic display

static int Dynamic = 0;
static int Delay = 0;

//  Max is determined by a scale

static int Max = 100;  

// The number generaror function

float generate ( int i, int max ) {
return sin( float( i * 10 ) / float(max) );
}

// Conversion to char*

char* float_text ( float f ) {
static char buf[512];
sprintf(buf,"%3.3f",f);
return buf;
}

char* int_text( int d ) {
static char buf[512];
sprintf(buf,"%d",d);
return buf;
}


// The scale handler

class scale_handler : public handler {
public:
scale_handler(scale* s) : _s(s) {}
int operator()() {
	Max = _s->get();
	return OK;
	}
private:
scale* _s;
};

// The start button handler

class number_handler : public handler {

public:

number_handler(canvas* _c, message* _m, scale* _s ) {
	c = _c; m = _m; s = _s; // g = _g;
	}

int operator()(){
	go();
	return OK;
	}

void go() { 

    tk->trace();

    c->del("num");
    //g->del("values");

    int num = Max;
    m->text( int_text( Max ) );

    //tclstring X;
    //tclstring Y;

    //g->insert("values","-color red -symbol solid -linewidth 2");
    //g->domain(1,Max);

    tk->notrace();

    tk->update();

    int l = 12;

    int offx = 20;
    int offy = 10;

    int w = width; int h = height;
    int dx = unit; int dy = 20;

    int px = offx, py = offy;


    for ( int i = 1; i < Max ; i++ ) {

    float f = generate(i,num);

    c->text(px,py, float_text( f ), "-anchor nw -tags num");

    //X->append( int_text(i) );
    //Y->append( float_text(f) );


    if (py < h - 2 * dy ) m->text( int_text( i ) );

    if (Dynamic) {
    	//g->add("values",X,Y);
	tk->update();
    	if (Delay > 0) tk->after(Delay);
	}


    px =  px + dx;
    if ( px > ( w - dx )) {
	px = offx;
	py = py + dy;
	//if ( py > ( h - dy ) ) break;
        }

    }
    //g->add("values",X,Y);

}

private:

canvas *c;
message* m;
scale* s;
//xygraph* g;
};


//// The application class:

class application : public session {
public:
application(int argc, char** argv) : session(argc,argv,"numbers") {}

int main() {
 
    // tk->trace();  // for debugging

    // A message

    message* vu = new message(".vu");
    vu->geometry(width - 4 * unit ,100);
    vu->configure("-font -Adobe-times-medium-r-normal--*-180*");
    vu->text("Number Generator  -- VU (1994)");

    // The canvas on which the numbers will be drawn.

    canvas* c = new canvas(".canvas");
    c->geometry(width,height);
    c->configure("-background white");

    // A frame for interface widgets

    frame* f = new frame(".f");

    ::button* b = new ::button(f,".b");
    b->text("start");

    scale* s = new scale(f,".s","-orient horizontal");
    s->to(MAX);
    s->bind(new scale_handler(s));
    s->set(Max);

    message* m = new message(f,".m");
    m->text( int_text( Max ) );


    // The graph

    //xygraph* g = new xygraph(".graph","-title values");
    //g->geometry(width, 2 * unit);
    //g->configure("-relief sunken");

    //g->insert("values","-color red -symbol solid -linewidth 2");

    //g->range(1,Max);
    //g->range(-1,1);    // is fixed

    // The number display class

    number_handler* h = new number_handler(c,m,s);

    b->bind(h);


    // Finally, the screen layout

    f->pack(b,"{left expand fill padx 10 pady 5}");
    f->pack(s,"{left expand fill}");
    f->pack(m,"{left  padx 20}");

    tk->pack(vu,"{top expand fill}");
    tk->pack(c);
    //tk->pack(g, "{top expand padx 10 pady 10}");
    tk->pack(f);

    tk->pack(".quit");
    return OK;
    }
};

//// The main function:

int main (int  argc, char  **argv) {
    session* s = new application(argc,argv);
    return s->run();
}


