!include install.inf

.SILENT


!ifdef DELETE_SOURCES
!if $(DELETE_SOURCES)!=0
RMDIRS = rmdirs
!endif
!endif
 
install: unpack mkresource install-hush $(RMDIRS) done


HUSH     = $(TARGETDRIVE)\hush	
API      = $(TARGETDRIVE)\api-2.0	
MSHUSH   = $(TARGETDRIVE)\mshush	# the mshush directory

SIM      = $(TARGETDRIVE)\sim-2.0
EXAMPLES = $(TARGETDRIVE)\exampl-2.0


!ifdef SIM
UNPACK_SIM  = unpack-sim
INSTALL_SIM = install-sim
RM_SIM_SRC  = rm-sim-dirs
SIM_PACKAGE_DEFINITION = SIM = $(SIM)
!endif

!ifdef EXAMPLES
UNPACK_EXAMPLES  = unpack-examples
INSTALL_EXAMPLES = install-examples
RM_EXAMPLES_SRC  = rm-examples-dirs
EXAMPLE_PACKAGE_DEFINITION = EXAMPLES = $(EXAMPLES)
!endif

unpack: unpack-start unpack-api unpack-mshush \
	$(UNPACK_SIM) $(UNPACK_EXAMPLES)

unpack-start:
	cls
	echo --- unpacking sources ---
	echo.
	$(TARGETDRIVE)
	cd \\

unpack-api:
	cls
	echo --- unpacking Hush API sources ---
	echo.
	$(INSTALLSOURCE)\unzip -qq $(INSTALLSOURCE)\api20.zip

unpack-mshush:
	cls
	echo --- unpacking MS-Hush sources ---
	echo.
	$(INSTALLSOURCE)\unzip -qq $(INSTALLSOURCE)\mshush.zip

unpack-sim:
	cls
	echo --- unpacking Sim sources ---
	echo.
	$(INSTALLSOURCE)\unzip -qq $(INSTALLSOURCE)\sim20.zip

unpack-examples:
	cls
	echo --- unpacking Example sources ---
	echo.
	-$(INSTALLSOURCE)\unzip -qq $(INSTALLSOURCE)\exampl20.zip


mkresource:
	cls
	echo --- installing configuration files ---
	echo.
	copy &&|
TOOLS=$(BORLANDTOOLS)		# compile tools
TCLTK=$(TCLTK)			# tcl dir

HUSH=$(HUSH)	# target dir
API =$(API)	# source dir

MSHUSH=$(MSHUSH)	
API_PACKAGE=$(INSTALLSOURCE)\api20.zip
$(SIM_PACKAGE_DEFINITION)
$(EXAMPLE_PACKAGE_DEFINITION)

.SILENT
| $(TARGETDRIVE)\mshush\resource.mak > nul
	del *.@@@


install-hush:
	cls
	echo --- installing Hush ---
	echo.
	cd \mshush
	install


rmdirs:	rm-api-dirs $(RM_SIM_SRC) $(RM_EXAMPLES_SRC)

rm-api-dirs:
	cls
	echo --- removing sources ---
	echo.
	cd \\
	cd $(HUSH)
	-deltree /Y $(MSHUSH)	
	-deltree /Y $(API)

rm-sim-dirs:
	-deltree /Y $(SIM)


rm-examples-dirs:
	-deltree /Y $(EXAMPLES)

done:
	cls
	echo --- done ---
	echo.
	cd \hush
	cd examples
	echo type "build" to create some example programs. 
	echo run drawtool\drawtool.exe or coffee\coffee.exe afterwards 
	echo from Windows to see if it worked, or test examples in other
	echo directories.
	echo.
